using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using Com.Telecomscloud.Api.TelecomsCloud.Client;
using Com.Telecomscloud.Api.TelecomsCloud.Model;

namespace Com.Telecomscloud.Api.TelecomsCloud.Api
{
    
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IVApi
    {
        
        /// <summary>
        /// Account Info
        /// </summary>
        /// <remarks>
        /// Provides account information
        /// </remarks>
        /// <returns>AccountInfoResponseModel</returns>
        AccountInfoResponseModel AccountInfo ();
  
        /// <summary>
        /// Account Info
        /// </summary>
        /// <remarks>
        /// Provides account information
        /// </remarks>
        /// <returns>ApiResponse of AccountInfoResponseModel</returns>
        ApiResponse<AccountInfoResponseModel> AccountInfoWithHttpInfo ();

        /// <summary>
        /// Account Info
        /// </summary>
        /// <remarks>
        /// Provides account information
        /// </remarks>
        /// <returns>Task of AccountInfoResponseModel</returns>
        System.Threading.Tasks.Task<AccountInfoResponseModel> AccountInfoAsync ();

        /// <summary>
        /// Account Info
        /// </summary>
        /// <remarks>
        /// Provides account information
        /// </remarks>
        /// <returns>Task of ApiResponse (AccountInfoResponseModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<AccountInfoResponseModel>> AccountInfoAsyncWithHttpInfo ();
        
        /// <summary>
        /// Request an access token using client credentials
        /// </summary>
        /// <remarks>
        /// Request an access token using client credentials. The returned access token can be used to make authenticated requests to any endpoint.
        /// </remarks>
        /// <param name="createGrantClient">client_id : string - Unique client ID as issued by service provider. May be passed in query, body or along with client_secret in a basic auth header. client_secret : string - Client secret as issued by service provider. May be passed in json body or along with client_id in a basic auth header.</param>
        /// <returns>ClientGrantResponseModel</returns>
        ClientGrantResponseModel CreateGrantClient (CreateGrantClient createGrantClient);
  
        /// <summary>
        /// Request an access token using client credentials
        /// </summary>
        /// <remarks>
        /// Request an access token using client credentials. The returned access token can be used to make authenticated requests to any endpoint.
        /// </remarks>
        /// <param name="createGrantClient">client_id : string - Unique client ID as issued by service provider. May be passed in query, body or along with client_secret in a basic auth header. client_secret : string - Client secret as issued by service provider. May be passed in json body or along with client_id in a basic auth header.</param>
        /// <returns>ApiResponse of ClientGrantResponseModel</returns>
        ApiResponse<ClientGrantResponseModel> CreateGrantClientWithHttpInfo (CreateGrantClient createGrantClient);

        /// <summary>
        /// Request an access token using client credentials
        /// </summary>
        /// <remarks>
        /// Request an access token using client credentials. The returned access token can be used to make authenticated requests to any endpoint.
        /// </remarks>
        /// <param name="createGrantClient">client_id : string - Unique client ID as issued by service provider. May be passed in query, body or along with client_secret in a basic auth header. client_secret : string - Client secret as issued by service provider. May be passed in json body or along with client_id in a basic auth header.</param>
        /// <returns>Task of ClientGrantResponseModel</returns>
        System.Threading.Tasks.Task<ClientGrantResponseModel> CreateGrantClientAsync (CreateGrantClient createGrantClient);

        /// <summary>
        /// Request an access token using client credentials
        /// </summary>
        /// <remarks>
        /// Request an access token using client credentials. The returned access token can be used to make authenticated requests to any endpoint.
        /// </remarks>
        /// <param name="createGrantClient">client_id : string - Unique client ID as issued by service provider. May be passed in query, body or along with client_secret in a basic auth header. client_secret : string - Client secret as issued by service provider. May be passed in json body or along with client_id in a basic auth header.</param>
        /// <returns>Task of ApiResponse (ClientGrantResponseModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<ClientGrantResponseModel>> CreateGrantClientAsyncWithHttpInfo (CreateGrantClient createGrantClient);
        
        /// <summary>
        /// Received Fax Info
        /// </summary>
        /// <remarks>
        /// Provides received fax information including the faxes Id which can be used to download the fax document and a &#39;pointer&#39;. Make an initial request with the last_pointer parameter set to 0 (zero), this will return any items received within the last 48 hours, or an empty array if no items have been received. Each item record returned will include a &#39;pointer&#39;, to get updates received after the last check, pass the highest pointer seen.
        /// </remarks>
        /// <param name="lastPointer">Latest known pointer, faxes records received after this will be returned. Enter 0 if unknown or no previous pointer..</param>
        /// <returns>FaxInfoCollectionResponseModel</returns>
        FaxInfoCollectionResponseModel RetrieveInfo (string lastPointer);
  
        /// <summary>
        /// Received Fax Info
        /// </summary>
        /// <remarks>
        /// Provides received fax information including the faxes Id which can be used to download the fax document and a &#39;pointer&#39;. Make an initial request with the last_pointer parameter set to 0 (zero), this will return any items received within the last 48 hours, or an empty array if no items have been received. Each item record returned will include a &#39;pointer&#39;, to get updates received after the last check, pass the highest pointer seen.
        /// </remarks>
        /// <param name="lastPointer">Latest known pointer, faxes records received after this will be returned. Enter 0 if unknown or no previous pointer..</param>
        /// <returns>ApiResponse of FaxInfoCollectionResponseModel</returns>
        ApiResponse<FaxInfoCollectionResponseModel> RetrieveInfoWithHttpInfo (string lastPointer);

        /// <summary>
        /// Received Fax Info
        /// </summary>
        /// <remarks>
        /// Provides received fax information including the faxes Id which can be used to download the fax document and a &#39;pointer&#39;. Make an initial request with the last_pointer parameter set to 0 (zero), this will return any items received within the last 48 hours, or an empty array if no items have been received. Each item record returned will include a &#39;pointer&#39;, to get updates received after the last check, pass the highest pointer seen.
        /// </remarks>
        /// <param name="lastPointer">Latest known pointer, faxes records received after this will be returned. Enter 0 if unknown or no previous pointer..</param>
        /// <returns>Task of FaxInfoCollectionResponseModel</returns>
        System.Threading.Tasks.Task<FaxInfoCollectionResponseModel> RetrieveInfoAsync (string lastPointer);

        /// <summary>
        /// Received Fax Info
        /// </summary>
        /// <remarks>
        /// Provides received fax information including the faxes Id which can be used to download the fax document and a &#39;pointer&#39;. Make an initial request with the last_pointer parameter set to 0 (zero), this will return any items received within the last 48 hours, or an empty array if no items have been received. Each item record returned will include a &#39;pointer&#39;, to get updates received after the last check, pass the highest pointer seen.
        /// </remarks>
        /// <param name="lastPointer">Latest known pointer, faxes records received after this will be returned. Enter 0 if unknown or no previous pointer..</param>
        /// <returns>Task of ApiResponse (FaxInfoCollectionResponseModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<FaxInfoCollectionResponseModel>> RetrieveInfoAsyncWithHttpInfo (string lastPointer);
        
        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// Retrieve fax
        /// </remarks>
        /// <param name="id">ID</param>
        /// <returns></returns>
        void RetrieveFax (string id);
  
        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// Retrieve fax
        /// </remarks>
        /// <param name="id">ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> RetrieveFaxWithHttpInfo (string id);

        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// Retrieve fax
        /// </remarks>
        /// <param name="id">ID</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task RetrieveFaxAsync (string id);

        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// Retrieve fax
        /// </remarks>
        /// <param name="id">ID</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> RetrieveFaxAsyncWithHttpInfo (string id);
        
        /// <summary>
        /// Submit a fax for sending
        /// </summary>
        /// <remarks>
        /// Post a PDF file as fax_document. Returns unique id.
        /// </remarks>
        /// <param name="to">Number to send fax to.</param>
        /// <param name="from">Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading &#39;+&#39;) or UK based number formatting by default.</param>
        /// <param name="faxDocument">Single PDF containing page(s) to be faxed.</param>
        /// <param name="numberFormatLocation">Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.</param>
        /// <returns>FaxOutboundSendResponseModel</returns>
        FaxOutboundSendResponseModel SendFax (string to, string from, Stream faxDocument, string numberFormatLocation = null);
  
        /// <summary>
        /// Submit a fax for sending
        /// </summary>
        /// <remarks>
        /// Post a PDF file as fax_document. Returns unique id.
        /// </remarks>
        /// <param name="to">Number to send fax to.</param>
        /// <param name="from">Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading &#39;+&#39;) or UK based number formatting by default.</param>
        /// <param name="faxDocument">Single PDF containing page(s) to be faxed.</param>
        /// <param name="numberFormatLocation">Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.</param>
        /// <returns>ApiResponse of FaxOutboundSendResponseModel</returns>
        ApiResponse<FaxOutboundSendResponseModel> SendFaxWithHttpInfo (string to, string from, Stream faxDocument, string numberFormatLocation = null);

        /// <summary>
        /// Submit a fax for sending
        /// </summary>
        /// <remarks>
        /// Post a PDF file as fax_document. Returns unique id.
        /// </remarks>
        /// <param name="to">Number to send fax to.</param>
        /// <param name="from">Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading &#39;+&#39;) or UK based number formatting by default.</param>
        /// <param name="faxDocument">Single PDF containing page(s) to be faxed.</param>
        /// <param name="numberFormatLocation">Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.</param>
        /// <returns>Task of FaxOutboundSendResponseModel</returns>
        System.Threading.Tasks.Task<FaxOutboundSendResponseModel> SendFaxAsync (string to, string from, Stream faxDocument, string numberFormatLocation = null);

        /// <summary>
        /// Submit a fax for sending
        /// </summary>
        /// <remarks>
        /// Post a PDF file as fax_document. Returns unique id.
        /// </remarks>
        /// <param name="to">Number to send fax to.</param>
        /// <param name="from">Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading &#39;+&#39;) or UK based number formatting by default.</param>
        /// <param name="faxDocument">Single PDF containing page(s) to be faxed.</param>
        /// <param name="numberFormatLocation">Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.</param>
        /// <returns>Task of ApiResponse (FaxOutboundSendResponseModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<FaxOutboundSendResponseModel>> SendFaxAsyncWithHttpInfo (string to, string from, Stream faxDocument, string numberFormatLocation = null);
        
        /// <summary>
        /// Get fax submission status updates
        /// </summary>
        /// <remarks>
        /// Retrieve any status updates for fax submissions since last checked.
        /// </remarks>
        /// <param name="lastPointer">Optional pointer, if not used last two days will be returned.</param>
        /// <returns>FaxOutboundGetUpdatesCollectionResponseModel</returns>
        FaxOutboundGetUpdatesCollectionResponseModel RetrieveFaxUpdates (string lastPointer = null);
  
        /// <summary>
        /// Get fax submission status updates
        /// </summary>
        /// <remarks>
        /// Retrieve any status updates for fax submissions since last checked.
        /// </remarks>
        /// <param name="lastPointer">Optional pointer, if not used last two days will be returned.</param>
        /// <returns>ApiResponse of FaxOutboundGetUpdatesCollectionResponseModel</returns>
        ApiResponse<FaxOutboundGetUpdatesCollectionResponseModel> RetrieveFaxUpdatesWithHttpInfo (string lastPointer = null);

        /// <summary>
        /// Get fax submission status updates
        /// </summary>
        /// <remarks>
        /// Retrieve any status updates for fax submissions since last checked.
        /// </remarks>
        /// <param name="lastPointer">Optional pointer, if not used last two days will be returned.</param>
        /// <returns>Task of FaxOutboundGetUpdatesCollectionResponseModel</returns>
        System.Threading.Tasks.Task<FaxOutboundGetUpdatesCollectionResponseModel> RetrieveFaxUpdatesAsync (string lastPointer = null);

        /// <summary>
        /// Get fax submission status updates
        /// </summary>
        /// <remarks>
        /// Retrieve any status updates for fax submissions since last checked.
        /// </remarks>
        /// <param name="lastPointer">Optional pointer, if not used last two days will be returned.</param>
        /// <returns>Task of ApiResponse (FaxOutboundGetUpdatesCollectionResponseModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<FaxOutboundGetUpdatesCollectionResponseModel>> RetrieveFaxUpdatesAsyncWithHttpInfo (string lastPointer = null);
        
        /// <summary>
        /// Check the status of a submitted fax.
        /// </summary>
        /// <remarks>
        /// Returns the status of the fax submission referenced by the passed Id
        /// </remarks>
        /// <param name="id">Id of message to check as provided on submission of Fax.</param>
        /// <returns>FaxOutboundGetStatusResponseModel</returns>
        FaxOutboundGetStatusResponseModel RetrieveFaxStatus (string id);
  
        /// <summary>
        /// Check the status of a submitted fax.
        /// </summary>
        /// <remarks>
        /// Returns the status of the fax submission referenced by the passed Id
        /// </remarks>
        /// <param name="id">Id of message to check as provided on submission of Fax.</param>
        /// <returns>ApiResponse of FaxOutboundGetStatusResponseModel</returns>
        ApiResponse<FaxOutboundGetStatusResponseModel> RetrieveFaxStatusWithHttpInfo (string id);

        /// <summary>
        /// Check the status of a submitted fax.
        /// </summary>
        /// <remarks>
        /// Returns the status of the fax submission referenced by the passed Id
        /// </remarks>
        /// <param name="id">Id of message to check as provided on submission of Fax.</param>
        /// <returns>Task of FaxOutboundGetStatusResponseModel</returns>
        System.Threading.Tasks.Task<FaxOutboundGetStatusResponseModel> RetrieveFaxStatusAsync (string id);

        /// <summary>
        /// Check the status of a submitted fax.
        /// </summary>
        /// <remarks>
        /// Returns the status of the fax submission referenced by the passed Id
        /// </remarks>
        /// <param name="id">Id of message to check as provided on submission of Fax.</param>
        /// <returns>Task of ApiResponse (FaxOutboundGetStatusResponseModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<FaxOutboundGetStatusResponseModel>> RetrieveFaxStatusAsyncWithHttpInfo (string id);
        
        /// <summary>
        /// Get E.164 format number
        /// </summary>
        /// <remarks>
        /// Provides an E.164 formatted (e.g. +441514962245) version of the provided national (e.g. 01514962245) format phone number
        /// </remarks>
        /// <param name="number">National format phone number (e.g. 01514962245).</param>
        /// <param name="location">Two letter country code matching the location the provided number is formatted for (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. +44 151 496 2245).</param>
        /// <returns>NumberFormatterResponseModel</returns>
        NumberFormatterResponseModel FormatE164 (string number, string location, string pretty = null);
  
        /// <summary>
        /// Get E.164 format number
        /// </summary>
        /// <remarks>
        /// Provides an E.164 formatted (e.g. +441514962245) version of the provided national (e.g. 01514962245) format phone number
        /// </remarks>
        /// <param name="number">National format phone number (e.g. 01514962245).</param>
        /// <param name="location">Two letter country code matching the location the provided number is formatted for (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. +44 151 496 2245).</param>
        /// <returns>ApiResponse of NumberFormatterResponseModel</returns>
        ApiResponse<NumberFormatterResponseModel> FormatE164WithHttpInfo (string number, string location, string pretty = null);

        /// <summary>
        /// Get E.164 format number
        /// </summary>
        /// <remarks>
        /// Provides an E.164 formatted (e.g. +441514962245) version of the provided national (e.g. 01514962245) format phone number
        /// </remarks>
        /// <param name="number">National format phone number (e.g. 01514962245).</param>
        /// <param name="location">Two letter country code matching the location the provided number is formatted for (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. +44 151 496 2245).</param>
        /// <returns>Task of NumberFormatterResponseModel</returns>
        System.Threading.Tasks.Task<NumberFormatterResponseModel> FormatE164Async (string number, string location, string pretty = null);

        /// <summary>
        /// Get E.164 format number
        /// </summary>
        /// <remarks>
        /// Provides an E.164 formatted (e.g. +441514962245) version of the provided national (e.g. 01514962245) format phone number
        /// </remarks>
        /// <param name="number">National format phone number (e.g. 01514962245).</param>
        /// <param name="location">Two letter country code matching the location the provided number is formatted for (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. +44 151 496 2245).</param>
        /// <returns>Task of ApiResponse (NumberFormatterResponseModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<NumberFormatterResponseModel>> FormatE164AsyncWithHttpInfo (string number, string location, string pretty = null);
        
        /// <summary>
        /// Get international format number
        /// </summary>
        /// <remarks>
        /// Converts the provided National format number (e.g. 01514962245) into an dialable number in the provided location (e.g. 011441514962245 for dialing GB from US)
        /// </remarks>
        /// <param name="number">Phone number in National format (e.g. 01514962245).</param>
        /// <param name="providedLocation">Two letter country code matching provided number format (e.g. GB).</param>
        /// <param name="dialFromLocation">Two letter country code of location dialling from (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 011 44 151 496 2245).</param>
        /// <returns>NumberFormatterResponseModel</returns>
        NumberFormatterResponseModel FormatInternational (string number, string providedLocation, string dialFromLocation, string pretty = null);
  
        /// <summary>
        /// Get international format number
        /// </summary>
        /// <remarks>
        /// Converts the provided National format number (e.g. 01514962245) into an dialable number in the provided location (e.g. 011441514962245 for dialing GB from US)
        /// </remarks>
        /// <param name="number">Phone number in National format (e.g. 01514962245).</param>
        /// <param name="providedLocation">Two letter country code matching provided number format (e.g. GB).</param>
        /// <param name="dialFromLocation">Two letter country code of location dialling from (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 011 44 151 496 2245).</param>
        /// <returns>ApiResponse of NumberFormatterResponseModel</returns>
        ApiResponse<NumberFormatterResponseModel> FormatInternationalWithHttpInfo (string number, string providedLocation, string dialFromLocation, string pretty = null);

        /// <summary>
        /// Get international format number
        /// </summary>
        /// <remarks>
        /// Converts the provided National format number (e.g. 01514962245) into an dialable number in the provided location (e.g. 011441514962245 for dialing GB from US)
        /// </remarks>
        /// <param name="number">Phone number in National format (e.g. 01514962245).</param>
        /// <param name="providedLocation">Two letter country code matching provided number format (e.g. GB).</param>
        /// <param name="dialFromLocation">Two letter country code of location dialling from (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 011 44 151 496 2245).</param>
        /// <returns>Task of NumberFormatterResponseModel</returns>
        System.Threading.Tasks.Task<NumberFormatterResponseModel> FormatInternationalAsync (string number, string providedLocation, string dialFromLocation, string pretty = null);

        /// <summary>
        /// Get international format number
        /// </summary>
        /// <remarks>
        /// Converts the provided National format number (e.g. 01514962245) into an dialable number in the provided location (e.g. 011441514962245 for dialing GB from US)
        /// </remarks>
        /// <param name="number">Phone number in National format (e.g. 01514962245).</param>
        /// <param name="providedLocation">Two letter country code matching provided number format (e.g. GB).</param>
        /// <param name="dialFromLocation">Two letter country code of location dialling from (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 011 44 151 496 2245).</param>
        /// <returns>Task of ApiResponse (NumberFormatterResponseModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<NumberFormatterResponseModel>> FormatInternationalAsyncWithHttpInfo (string number, string providedLocation, string dialFromLocation, string pretty = null);
        
        /// <summary>
        /// Get national format number
        /// </summary>
        /// <remarks>
        /// Provides the national (e.g. 01514962245) format variant of the provided E.164 (e.g. +441514962245)
        /// </remarks>
        /// <param name="number">Phone number in E.164 format (e.g. +441514962245).</param>
        /// <param name="location">Two letter country code (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 0151 496 2245).</param>
        /// <returns>NumberFormatterResponseModel</returns>
        NumberFormatterResponseModel FormatNational (string number, string location, string pretty = null);
  
        /// <summary>
        /// Get national format number
        /// </summary>
        /// <remarks>
        /// Provides the national (e.g. 01514962245) format variant of the provided E.164 (e.g. +441514962245)
        /// </remarks>
        /// <param name="number">Phone number in E.164 format (e.g. +441514962245).</param>
        /// <param name="location">Two letter country code (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 0151 496 2245).</param>
        /// <returns>ApiResponse of NumberFormatterResponseModel</returns>
        ApiResponse<NumberFormatterResponseModel> FormatNationalWithHttpInfo (string number, string location, string pretty = null);

        /// <summary>
        /// Get national format number
        /// </summary>
        /// <remarks>
        /// Provides the national (e.g. 01514962245) format variant of the provided E.164 (e.g. +441514962245)
        /// </remarks>
        /// <param name="number">Phone number in E.164 format (e.g. +441514962245).</param>
        /// <param name="location">Two letter country code (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 0151 496 2245).</param>
        /// <returns>Task of NumberFormatterResponseModel</returns>
        System.Threading.Tasks.Task<NumberFormatterResponseModel> FormatNationalAsync (string number, string location, string pretty = null);

        /// <summary>
        /// Get national format number
        /// </summary>
        /// <remarks>
        /// Provides the national (e.g. 01514962245) format variant of the provided E.164 (e.g. +441514962245)
        /// </remarks>
        /// <param name="number">Phone number in E.164 format (e.g. +441514962245).</param>
        /// <param name="location">Two letter country code (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 0151 496 2245).</param>
        /// <returns>Task of ApiResponse (NumberFormatterResponseModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<NumberFormatterResponseModel>> FormatNationalAsyncWithHttpInfo (string number, string location, string pretty = null);
        
        /// <summary>
        /// Get pretty number
        /// </summary>
        /// <remarks>
        /// Uses whitespace to provide human readable numbers
        /// </remarks>
        /// <param name="number">Phone number to format (e.g. 01514962245, 011441514962245, +441514962245).</param>
        /// <param name="location">Two letter country code matching provided number format (e.g. GB).</param>
        /// <returns>NumberFormatterResponseModel</returns>
        NumberFormatterResponseModel FormatPretty (string number, string location);
  
        /// <summary>
        /// Get pretty number
        /// </summary>
        /// <remarks>
        /// Uses whitespace to provide human readable numbers
        /// </remarks>
        /// <param name="number">Phone number to format (e.g. 01514962245, 011441514962245, +441514962245).</param>
        /// <param name="location">Two letter country code matching provided number format (e.g. GB).</param>
        /// <returns>ApiResponse of NumberFormatterResponseModel</returns>
        ApiResponse<NumberFormatterResponseModel> FormatPrettyWithHttpInfo (string number, string location);

        /// <summary>
        /// Get pretty number
        /// </summary>
        /// <remarks>
        /// Uses whitespace to provide human readable numbers
        /// </remarks>
        /// <param name="number">Phone number to format (e.g. 01514962245, 011441514962245, +441514962245).</param>
        /// <param name="location">Two letter country code matching provided number format (e.g. GB).</param>
        /// <returns>Task of NumberFormatterResponseModel</returns>
        System.Threading.Tasks.Task<NumberFormatterResponseModel> FormatPrettyAsync (string number, string location);

        /// <summary>
        /// Get pretty number
        /// </summary>
        /// <remarks>
        /// Uses whitespace to provide human readable numbers
        /// </remarks>
        /// <param name="number">Phone number to format (e.g. 01514962245, 011441514962245, +441514962245).</param>
        /// <param name="location">Two letter country code matching provided number format (e.g. GB).</param>
        /// <returns>Task of ApiResponse (NumberFormatterResponseModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<NumberFormatterResponseModel>> FormatPrettyAsyncWithHttpInfo (string number, string location);
        
        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// Retrieve locality info
        /// </remarks>
        /// <param name="phoneNumber">Phone number</param>
        /// <returns>LocalityInfoResponseModel</returns>
        LocalityInfoResponseModel RetrieveLocalityInfo (string phoneNumber);
  
        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// Retrieve locality info
        /// </remarks>
        /// <param name="phoneNumber">Phone number</param>
        /// <returns>ApiResponse of LocalityInfoResponseModel</returns>
        ApiResponse<LocalityInfoResponseModel> RetrieveLocalityInfoWithHttpInfo (string phoneNumber);

        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// Retrieve locality info
        /// </remarks>
        /// <param name="phoneNumber">Phone number</param>
        /// <returns>Task of LocalityInfoResponseModel</returns>
        System.Threading.Tasks.Task<LocalityInfoResponseModel> RetrieveLocalityInfoAsync (string phoneNumber);

        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// Retrieve locality info
        /// </remarks>
        /// <param name="phoneNumber">Phone number</param>
        /// <returns>Task of ApiResponse (LocalityInfoResponseModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<LocalityInfoResponseModel>> RetrieveLocalityInfoAsyncWithHttpInfo (string phoneNumber);
        
        /// <summary>
        /// Check Telephone Preference Service
        /// </summary>
        /// <remarks>
        /// Check if provided number is included in the Telephony Preference Service list. Returns true or false.
        /// </remarks>
        /// <param name="phoneNumber">Phone number to lookup in E.164 format or national format according to numberFormatLocation.</param>
        /// <param name="numberFormatLocation">Optional; ISO 3166-1 alpha-2 Two letter country code matching the origin of the provided number format, defaults to GB.</param>
        /// <returns></returns>
        void RetrieveTps (string phoneNumber, string numberFormatLocation = null);
  
        /// <summary>
        /// Check Telephone Preference Service
        /// </summary>
        /// <remarks>
        /// Check if provided number is included in the Telephony Preference Service list. Returns true or false.
        /// </remarks>
        /// <param name="phoneNumber">Phone number to lookup in E.164 format or national format according to numberFormatLocation.</param>
        /// <param name="numberFormatLocation">Optional; ISO 3166-1 alpha-2 Two letter country code matching the origin of the provided number format, defaults to GB.</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> RetrieveTpsWithHttpInfo (string phoneNumber, string numberFormatLocation = null);

        /// <summary>
        /// Check Telephone Preference Service
        /// </summary>
        /// <remarks>
        /// Check if provided number is included in the Telephony Preference Service list. Returns true or false.
        /// </remarks>
        /// <param name="phoneNumber">Phone number to lookup in E.164 format or national format according to numberFormatLocation.</param>
        /// <param name="numberFormatLocation">Optional; ISO 3166-1 alpha-2 Two letter country code matching the origin of the provided number format, defaults to GB.</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task RetrieveTpsAsync (string phoneNumber, string numberFormatLocation = null);

        /// <summary>
        /// Check Telephone Preference Service
        /// </summary>
        /// <remarks>
        /// Check if provided number is included in the Telephony Preference Service list. Returns true or false.
        /// </remarks>
        /// <param name="phoneNumber">Phone number to lookup in E.164 format or national format according to numberFormatLocation.</param>
        /// <param name="numberFormatLocation">Optional; ISO 3166-1 alpha-2 Two letter country code matching the origin of the provided number format, defaults to GB.</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> RetrieveTpsAsyncWithHttpInfo (string phoneNumber, string numberFormatLocation = null);
        
        /// <summary>
        /// Send an SMS Text Message
        /// </summary>
        /// <remarks>
        /// Send an SMS message from one of your TC numbers, or the default number (this can be found on the API Access settings on the TelecomsCloud website). SMS message is queued for delivery to the specified recipient, returning a unique reference on success. This reference can be used to check the status of the submitted message.
        /// </remarks>
        /// <param name="smsOutboundSendResponseModel">* to : string (required) - Number to send message to.  * from : string (required) - Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading &#39;+&#39;) or UK based number formatting by default.  * message : string (required) - Message to send to recipient, up to 160 chars.  * numberFormatLocation : string - Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.</param>
        /// <returns>SmsOutboundSendResponseModel</returns>
        SmsOutboundSendResponseModel SendSms (SmsOutboundSendResponseModel smsOutboundSendResponseModel);
  
        /// <summary>
        /// Send an SMS Text Message
        /// </summary>
        /// <remarks>
        /// Send an SMS message from one of your TC numbers, or the default number (this can be found on the API Access settings on the TelecomsCloud website). SMS message is queued for delivery to the specified recipient, returning a unique reference on success. This reference can be used to check the status of the submitted message.
        /// </remarks>
        /// <param name="smsOutboundSendResponseModel">* to : string (required) - Number to send message to.  * from : string (required) - Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading &#39;+&#39;) or UK based number formatting by default.  * message : string (required) - Message to send to recipient, up to 160 chars.  * numberFormatLocation : string - Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.</param>
        /// <returns>ApiResponse of SmsOutboundSendResponseModel</returns>
        ApiResponse<SmsOutboundSendResponseModel> SendSmsWithHttpInfo (SmsOutboundSendResponseModel smsOutboundSendResponseModel);

        /// <summary>
        /// Send an SMS Text Message
        /// </summary>
        /// <remarks>
        /// Send an SMS message from one of your TC numbers, or the default number (this can be found on the API Access settings on the TelecomsCloud website). SMS message is queued for delivery to the specified recipient, returning a unique reference on success. This reference can be used to check the status of the submitted message.
        /// </remarks>
        /// <param name="smsOutboundSendResponseModel">* to : string (required) - Number to send message to.  * from : string (required) - Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading &#39;+&#39;) or UK based number formatting by default.  * message : string (required) - Message to send to recipient, up to 160 chars.  * numberFormatLocation : string - Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.</param>
        /// <returns>Task of SmsOutboundSendResponseModel</returns>
        System.Threading.Tasks.Task<SmsOutboundSendResponseModel> SendSmsAsync (SmsOutboundSendResponseModel smsOutboundSendResponseModel);

        /// <summary>
        /// Send an SMS Text Message
        /// </summary>
        /// <remarks>
        /// Send an SMS message from one of your TC numbers, or the default number (this can be found on the API Access settings on the TelecomsCloud website). SMS message is queued for delivery to the specified recipient, returning a unique reference on success. This reference can be used to check the status of the submitted message.
        /// </remarks>
        /// <param name="smsOutboundSendResponseModel">* to : string (required) - Number to send message to.  * from : string (required) - Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading &#39;+&#39;) or UK based number formatting by default.  * message : string (required) - Message to send to recipient, up to 160 chars.  * numberFormatLocation : string - Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.</param>
        /// <returns>Task of ApiResponse (SmsOutboundSendResponseModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<SmsOutboundSendResponseModel>> SendSmsAsyncWithHttpInfo (SmsOutboundSendResponseModel smsOutboundSendResponseModel);
        
        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// Get sms status
        /// </remarks>
        /// <param name="smsId">Sms ID</param>
        /// <returns>SmsOutboundGetStatusResponseModel</returns>
        SmsOutboundGetStatusResponseModel GetSmsStatus (string smsId);
  
        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// Get sms status
        /// </remarks>
        /// <param name="smsId">Sms ID</param>
        /// <returns>ApiResponse of SmsOutboundGetStatusResponseModel</returns>
        ApiResponse<SmsOutboundGetStatusResponseModel> GetSmsStatusWithHttpInfo (string smsId);

        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// Get sms status
        /// </remarks>
        /// <param name="smsId">Sms ID</param>
        /// <returns>Task of SmsOutboundGetStatusResponseModel</returns>
        System.Threading.Tasks.Task<SmsOutboundGetStatusResponseModel> GetSmsStatusAsync (string smsId);

        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// Get sms status
        /// </remarks>
        /// <param name="smsId">Sms ID</param>
        /// <returns>Task of ApiResponse (SmsOutboundGetStatusResponseModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<SmsOutboundGetStatusResponseModel>> GetSmsStatusAsyncWithHttpInfo (string smsId);
        
    }
  
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public class VApi : IVApi
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="VApi"/> class.
        /// </summary>
        /// <returns></returns>
        public VApi(String basePath)
        {
            this.Configuration = new Configuration(new ApiClient(basePath));
        }
    
        /// <summary>
        /// Initializes a new instance of the <see cref="VApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public VApi(Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Configuration.Default; 
            else
                this.Configuration = configuration;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuraiton.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }
    
        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Configuration Configuration {get; set;}

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public Dictionary<String, String> DefaultHeader()
        {
            return this.Configuration.DefaultHeader;
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }
   
        
        /// <summary>
        /// Account Info Provides account information
        /// </summary>
        /// <returns>AccountInfoResponseModel</returns>
        public AccountInfoResponseModel AccountInfo ()
        {
             ApiResponse<AccountInfoResponseModel> response = AccountInfoWithHttpInfo();
             return response.Data;
        }

        /// <summary>
        /// Account Info Provides account information
        /// </summary>
        /// <returns>ApiResponse of AccountInfoResponseModel</returns>
        public ApiResponse< AccountInfoResponseModel > AccountInfoWithHttpInfo ()
        {
            
    
            var path_ = "/v1/account/info";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            
            
            
            
            

            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            
    
            // make the HTTP request
            IRestResponse response = (IRestResponse) Configuration.ApiClient.CallApi(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams,
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
    
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling AccountInfo: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling AccountInfo: " + response.ErrorMessage, response.ErrorMessage);
    
            return new ApiResponse<AccountInfoResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (AccountInfoResponseModel) Configuration.ApiClient.Deserialize(response, typeof(AccountInfoResponseModel)));
            
        }
    
        /// <summary>
        /// Account Info Provides account information
        /// </summary>
        /// <returns>Task of AccountInfoResponseModel</returns>
        public async System.Threading.Tasks.Task<AccountInfoResponseModel> AccountInfoAsync ()
        {
             ApiResponse<AccountInfoResponseModel> response = await AccountInfoAsyncWithHttpInfo();
             return response.Data;

        }

        /// <summary>
        /// Account Info Provides account information
        /// </summary>
        /// <returns>Task of ApiResponse (AccountInfoResponseModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<AccountInfoResponseModel>> AccountInfoAsyncWithHttpInfo ()
        {
            
    
            var path_ = "/v1/account/info";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>();
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            
            
            
            
            

            
            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            

            // make the HTTP request
            IRestResponse response = (IRestResponse) await Configuration.ApiClient.CallApiAsync(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams, 
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
 
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling AccountInfo: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling AccountInfo: " + response.ErrorMessage, response.ErrorMessage);

            return new ApiResponse<AccountInfoResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (AccountInfoResponseModel) Configuration.ApiClient.Deserialize(response, typeof(AccountInfoResponseModel)));
            
        }
        
        /// <summary>
        /// Request an access token using client credentials Request an access token using client credentials. The returned access token can be used to make authenticated requests to any endpoint.
        /// </summary>
        /// <param name="createGrantClient">client_id : string - Unique client ID as issued by service provider. May be passed in query, body or along with client_secret in a basic auth header. client_secret : string - Client secret as issued by service provider. May be passed in json body or along with client_id in a basic auth header.</param> 
        /// <returns>ClientGrantResponseModel</returns>
        public ClientGrantResponseModel CreateGrantClient (CreateGrantClient createGrantClient)
        {
             ApiResponse<ClientGrantResponseModel> response = CreateGrantClientWithHttpInfo(createGrantClient);
             return response.Data;
        }

        /// <summary>
        /// Request an access token using client credentials Request an access token using client credentials. The returned access token can be used to make authenticated requests to any endpoint.
        /// </summary>
        /// <param name="createGrantClient">client_id : string - Unique client ID as issued by service provider. May be passed in query, body or along with client_secret in a basic auth header. client_secret : string - Client secret as issued by service provider. May be passed in json body or along with client_id in a basic auth header.</param> 
        /// <returns>ApiResponse of ClientGrantResponseModel</returns>
        public ApiResponse< ClientGrantResponseModel > CreateGrantClientWithHttpInfo (CreateGrantClient createGrantClient)
        {
            
            // verify the required parameter 'createGrantClient' is set
            if (createGrantClient == null)
                throw new ApiException(400, "Missing required parameter 'createGrantClient' when calling VApi->CreateGrantClient");
            
    
            var path_ = "/v1/authorization/oauth2/grant-client";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                "application/json"
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            
            
            
            
            if (createGrantClient.GetType() != typeof(byte[]))
            {
                postBody = Configuration.ApiClient.Serialize(createGrantClient); // http body (model) parameter
            }
            else
            {
                postBody = createGrantClient; // byte array
            }

            
    
            // make the HTTP request
            IRestResponse response = (IRestResponse) Configuration.ApiClient.CallApi(path_, 
                Method.POST, queryParams, postBody, headerParams, formParams, fileParams,
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
    
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling CreateGrantClient: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling CreateGrantClient: " + response.ErrorMessage, response.ErrorMessage);
    
            return new ApiResponse<ClientGrantResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ClientGrantResponseModel) Configuration.ApiClient.Deserialize(response, typeof(ClientGrantResponseModel)));
            
        }
    
        /// <summary>
        /// Request an access token using client credentials Request an access token using client credentials. The returned access token can be used to make authenticated requests to any endpoint.
        /// </summary>
        /// <param name="createGrantClient">client_id : string - Unique client ID as issued by service provider. May be passed in query, body or along with client_secret in a basic auth header. client_secret : string - Client secret as issued by service provider. May be passed in json body or along with client_id in a basic auth header.</param>
        /// <returns>Task of ClientGrantResponseModel</returns>
        public async System.Threading.Tasks.Task<ClientGrantResponseModel> CreateGrantClientAsync (CreateGrantClient createGrantClient)
        {
             ApiResponse<ClientGrantResponseModel> response = await CreateGrantClientAsyncWithHttpInfo(createGrantClient);
             return response.Data;

        }

        /// <summary>
        /// Request an access token using client credentials Request an access token using client credentials. The returned access token can be used to make authenticated requests to any endpoint.
        /// </summary>
        /// <param name="createGrantClient">client_id : string - Unique client ID as issued by service provider. May be passed in query, body or along with client_secret in a basic auth header. client_secret : string - Client secret as issued by service provider. May be passed in json body or along with client_id in a basic auth header.</param>
        /// <returns>Task of ApiResponse (ClientGrantResponseModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ClientGrantResponseModel>> CreateGrantClientAsyncWithHttpInfo (CreateGrantClient createGrantClient)
        {
            // verify the required parameter 'createGrantClient' is set
            if (createGrantClient == null) throw new ApiException(400, "Missing required parameter 'createGrantClient' when calling CreateGrantClient");
            
    
            var path_ = "/v1/authorization/oauth2/grant-client";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>();
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                "application/json"
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            
            
            
            
            postBody = Configuration.ApiClient.Serialize(createGrantClient); // http body (model) parameter
            

            

            // make the HTTP request
            IRestResponse response = (IRestResponse) await Configuration.ApiClient.CallApiAsync(path_, 
                Method.POST, queryParams, postBody, headerParams, formParams, fileParams, 
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
 
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling CreateGrantClient: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling CreateGrantClient: " + response.ErrorMessage, response.ErrorMessage);

            return new ApiResponse<ClientGrantResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ClientGrantResponseModel) Configuration.ApiClient.Deserialize(response, typeof(ClientGrantResponseModel)));
            
        }
        
        /// <summary>
        /// Received Fax Info Provides received fax information including the faxes Id which can be used to download the fax document and a &#39;pointer&#39;. Make an initial request with the last_pointer parameter set to 0 (zero), this will return any items received within the last 48 hours, or an empty array if no items have been received. Each item record returned will include a &#39;pointer&#39;, to get updates received after the last check, pass the highest pointer seen.
        /// </summary>
        /// <param name="lastPointer">Latest known pointer, faxes records received after this will be returned. Enter 0 if unknown or no previous pointer..</param> 
        /// <returns>FaxInfoCollectionResponseModel</returns>
        public FaxInfoCollectionResponseModel RetrieveInfo (string lastPointer)
        {
             ApiResponse<FaxInfoCollectionResponseModel> response = RetrieveInfoWithHttpInfo(lastPointer);
             return response.Data;
        }

        /// <summary>
        /// Received Fax Info Provides received fax information including the faxes Id which can be used to download the fax document and a &#39;pointer&#39;. Make an initial request with the last_pointer parameter set to 0 (zero), this will return any items received within the last 48 hours, or an empty array if no items have been received. Each item record returned will include a &#39;pointer&#39;, to get updates received after the last check, pass the highest pointer seen.
        /// </summary>
        /// <param name="lastPointer">Latest known pointer, faxes records received after this will be returned. Enter 0 if unknown or no previous pointer..</param> 
        /// <returns>ApiResponse of FaxInfoCollectionResponseModel</returns>
        public ApiResponse< FaxInfoCollectionResponseModel > RetrieveInfoWithHttpInfo (string lastPointer)
        {
            
            // verify the required parameter 'lastPointer' is set
            if (lastPointer == null)
                throw new ApiException(400, "Missing required parameter 'lastPointer' when calling VApi->RetrieveInfo");
            
    
            var path_ = "/v1/fax/inbound/info";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            
            if (lastPointer != null) queryParams.Add("last_pointer", Configuration.ApiClient.ParameterToString(lastPointer)); // query parameter
            
            
            
            

            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            
    
            // make the HTTP request
            IRestResponse response = (IRestResponse) Configuration.ApiClient.CallApi(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams,
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
    
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling RetrieveInfo: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling RetrieveInfo: " + response.ErrorMessage, response.ErrorMessage);
    
            return new ApiResponse<FaxInfoCollectionResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (FaxInfoCollectionResponseModel) Configuration.ApiClient.Deserialize(response, typeof(FaxInfoCollectionResponseModel)));
            
        }
    
        /// <summary>
        /// Received Fax Info Provides received fax information including the faxes Id which can be used to download the fax document and a &#39;pointer&#39;. Make an initial request with the last_pointer parameter set to 0 (zero), this will return any items received within the last 48 hours, or an empty array if no items have been received. Each item record returned will include a &#39;pointer&#39;, to get updates received after the last check, pass the highest pointer seen.
        /// </summary>
        /// <param name="lastPointer">Latest known pointer, faxes records received after this will be returned. Enter 0 if unknown or no previous pointer..</param>
        /// <returns>Task of FaxInfoCollectionResponseModel</returns>
        public async System.Threading.Tasks.Task<FaxInfoCollectionResponseModel> RetrieveInfoAsync (string lastPointer)
        {
             ApiResponse<FaxInfoCollectionResponseModel> response = await RetrieveInfoAsyncWithHttpInfo(lastPointer);
             return response.Data;

        }

        /// <summary>
        /// Received Fax Info Provides received fax information including the faxes Id which can be used to download the fax document and a &#39;pointer&#39;. Make an initial request with the last_pointer parameter set to 0 (zero), this will return any items received within the last 48 hours, or an empty array if no items have been received. Each item record returned will include a &#39;pointer&#39;, to get updates received after the last check, pass the highest pointer seen.
        /// </summary>
        /// <param name="lastPointer">Latest known pointer, faxes records received after this will be returned. Enter 0 if unknown or no previous pointer..</param>
        /// <returns>Task of ApiResponse (FaxInfoCollectionResponseModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<FaxInfoCollectionResponseModel>> RetrieveInfoAsyncWithHttpInfo (string lastPointer)
        {
            // verify the required parameter 'lastPointer' is set
            if (lastPointer == null) throw new ApiException(400, "Missing required parameter 'lastPointer' when calling RetrieveInfo");
            
    
            var path_ = "/v1/fax/inbound/info";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>();
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            
            if (lastPointer != null) queryParams.Add("last_pointer", Configuration.ApiClient.ParameterToString(lastPointer)); // query parameter
            
            
            
            

            
            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            

            // make the HTTP request
            IRestResponse response = (IRestResponse) await Configuration.ApiClient.CallApiAsync(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams, 
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
 
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling RetrieveInfo: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling RetrieveInfo: " + response.ErrorMessage, response.ErrorMessage);

            return new ApiResponse<FaxInfoCollectionResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (FaxInfoCollectionResponseModel) Configuration.ApiClient.Deserialize(response, typeof(FaxInfoCollectionResponseModel)));
            
        }
        
        /// <summary>
        ///  Retrieve fax
        /// </summary>
        /// <param name="id">ID</param> 
        /// <returns></returns>
        public void RetrieveFax (string id)
        {
             RetrieveFaxWithHttpInfo(id);
        }

        /// <summary>
        ///  Retrieve fax
        /// </summary>
        /// <param name="id">ID</param> 
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> RetrieveFaxWithHttpInfo (string id)
        {
            
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling VApi->RetrieveFax");
            
    
            var path_ = "/v1/fax/inbound/{id}";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (id != null) pathParams.Add("id", Configuration.ApiClient.ParameterToString(id)); // path parameter
            
            
            
            
            

            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            
    
            // make the HTTP request
            IRestResponse response = (IRestResponse) Configuration.ApiClient.CallApi(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams,
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
    
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling RetrieveFax: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling RetrieveFax: " + response.ErrorMessage, response.ErrorMessage);
    
            
            return new ApiResponse<Object>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }
    
        /// <summary>
        ///  Retrieve fax
        /// </summary>
        /// <param name="id">ID</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task RetrieveFaxAsync (string id)
        {
             await RetrieveFaxAsyncWithHttpInfo(id);

        }

        /// <summary>
        ///  Retrieve fax
        /// </summary>
        /// <param name="id">ID</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> RetrieveFaxAsyncWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null) throw new ApiException(400, "Missing required parameter 'id' when calling RetrieveFax");
            
    
            var path_ = "/v1/fax/inbound/{id}";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>();
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (id != null) pathParams.Add("id", Configuration.ApiClient.ParameterToString(id)); // path parameter
            
            
            
            
            

            
            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            

            // make the HTTP request
            IRestResponse response = (IRestResponse) await Configuration.ApiClient.CallApiAsync(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams, 
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
 
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling RetrieveFax: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling RetrieveFax: " + response.ErrorMessage, response.ErrorMessage);

            
            return new ApiResponse<Object>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }
        
        /// <summary>
        /// Submit a fax for sending Post a PDF file as fax_document. Returns unique id.
        /// </summary>
        /// <param name="to">Number to send fax to.</param> 
        /// <param name="from">Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading &#39;+&#39;) or UK based number formatting by default.</param> 
        /// <param name="faxDocument">Single PDF containing page(s) to be faxed.</param> 
        /// <param name="numberFormatLocation">Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.</param> 
        /// <returns>FaxOutboundSendResponseModel</returns>
        public FaxOutboundSendResponseModel SendFax (string to, string from, Stream faxDocument, string numberFormatLocation = null)
        {
             ApiResponse<FaxOutboundSendResponseModel> response = SendFaxWithHttpInfo(to, from, faxDocument, numberFormatLocation);
             return response.Data;
        }

        /// <summary>
        /// Submit a fax for sending Post a PDF file as fax_document. Returns unique id.
        /// </summary>
        /// <param name="to">Number to send fax to.</param> 
        /// <param name="from">Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading &#39;+&#39;) or UK based number formatting by default.</param> 
        /// <param name="faxDocument">Single PDF containing page(s) to be faxed.</param> 
        /// <param name="numberFormatLocation">Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.</param> 
        /// <returns>ApiResponse of FaxOutboundSendResponseModel</returns>
        public ApiResponse< FaxOutboundSendResponseModel > SendFaxWithHttpInfo (string to, string from, Stream faxDocument, string numberFormatLocation = null)
        {
            
            // verify the required parameter 'to' is set
            if (to == null)
                throw new ApiException(400, "Missing required parameter 'to' when calling VApi->SendFax");
            
            // verify the required parameter 'from' is set
            if (from == null)
                throw new ApiException(400, "Missing required parameter 'from' when calling VApi->SendFax");
            
            // verify the required parameter 'faxDocument' is set
            if (faxDocument == null)
                throw new ApiException(400, "Missing required parameter 'faxDocument' when calling VApi->SendFax");
            
    
            var path_ = "/v1/fax/outbound";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                "multipart/form-data"
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            
            if (to != null) queryParams.Add("to", Configuration.ApiClient.ParameterToString(to)); // query parameter
            if (from != null) queryParams.Add("from", Configuration.ApiClient.ParameterToString(from)); // query parameter
            if (numberFormatLocation != null) queryParams.Add("numberFormatLocation", Configuration.ApiClient.ParameterToString(numberFormatLocation)); // query parameter
            
            
            if (faxDocument != null) fileParams.Add("fax_document", Configuration.ApiClient.ParameterToFile("fax_document", faxDocument));
            
            

            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            
    
            // make the HTTP request
            IRestResponse response = (IRestResponse) Configuration.ApiClient.CallApi(path_, 
                Method.POST, queryParams, postBody, headerParams, formParams, fileParams,
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
    
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling SendFax: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling SendFax: " + response.ErrorMessage, response.ErrorMessage);
    
            return new ApiResponse<FaxOutboundSendResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (FaxOutboundSendResponseModel) Configuration.ApiClient.Deserialize(response, typeof(FaxOutboundSendResponseModel)));
            
        }
    
        /// <summary>
        /// Submit a fax for sending Post a PDF file as fax_document. Returns unique id.
        /// </summary>
        /// <param name="to">Number to send fax to.</param>
        /// <param name="from">Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading &#39;+&#39;) or UK based number formatting by default.</param>
        /// <param name="faxDocument">Single PDF containing page(s) to be faxed.</param>
        /// <param name="numberFormatLocation">Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.</param>
        /// <returns>Task of FaxOutboundSendResponseModel</returns>
        public async System.Threading.Tasks.Task<FaxOutboundSendResponseModel> SendFaxAsync (string to, string from, Stream faxDocument, string numberFormatLocation = null)
        {
             ApiResponse<FaxOutboundSendResponseModel> response = await SendFaxAsyncWithHttpInfo(to, from, faxDocument, numberFormatLocation);
             return response.Data;

        }

        /// <summary>
        /// Submit a fax for sending Post a PDF file as fax_document. Returns unique id.
        /// </summary>
        /// <param name="to">Number to send fax to.</param>
        /// <param name="from">Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading &#39;+&#39;) or UK based number formatting by default.</param>
        /// <param name="faxDocument">Single PDF containing page(s) to be faxed.</param>
        /// <param name="numberFormatLocation">Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.</param>
        /// <returns>Task of ApiResponse (FaxOutboundSendResponseModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<FaxOutboundSendResponseModel>> SendFaxAsyncWithHttpInfo (string to, string from, Stream faxDocument, string numberFormatLocation = null)
        {
            // verify the required parameter 'to' is set
            if (to == null) throw new ApiException(400, "Missing required parameter 'to' when calling SendFax");
            // verify the required parameter 'from' is set
            if (from == null) throw new ApiException(400, "Missing required parameter 'from' when calling SendFax");
            // verify the required parameter 'faxDocument' is set
            if (faxDocument == null) throw new ApiException(400, "Missing required parameter 'faxDocument' when calling SendFax");
            
    
            var path_ = "/v1/fax/outbound";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>();
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                "multipart/form-data"
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            
            if (to != null) queryParams.Add("to", Configuration.ApiClient.ParameterToString(to)); // query parameter
            if (from != null) queryParams.Add("from", Configuration.ApiClient.ParameterToString(from)); // query parameter
            if (numberFormatLocation != null) queryParams.Add("numberFormatLocation", Configuration.ApiClient.ParameterToString(numberFormatLocation)); // query parameter
            
            
            if (faxDocument != null) fileParams.Add("fax_document", Configuration.ApiClient.ParameterToFile("fax_document", faxDocument));
            
            

            
            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            

            // make the HTTP request
            IRestResponse response = (IRestResponse) await Configuration.ApiClient.CallApiAsync(path_, 
                Method.POST, queryParams, postBody, headerParams, formParams, fileParams, 
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
 
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling SendFax: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling SendFax: " + response.ErrorMessage, response.ErrorMessage);

            return new ApiResponse<FaxOutboundSendResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (FaxOutboundSendResponseModel) Configuration.ApiClient.Deserialize(response, typeof(FaxOutboundSendResponseModel)));
            
        }
        
        /// <summary>
        /// Get fax submission status updates Retrieve any status updates for fax submissions since last checked.
        /// </summary>
        /// <param name="lastPointer">Optional pointer, if not used last two days will be returned.</param> 
        /// <returns>FaxOutboundGetUpdatesCollectionResponseModel</returns>
        public FaxOutboundGetUpdatesCollectionResponseModel RetrieveFaxUpdates (string lastPointer = null)
        {
             ApiResponse<FaxOutboundGetUpdatesCollectionResponseModel> response = RetrieveFaxUpdatesWithHttpInfo(lastPointer);
             return response.Data;
        }

        /// <summary>
        /// Get fax submission status updates Retrieve any status updates for fax submissions since last checked.
        /// </summary>
        /// <param name="lastPointer">Optional pointer, if not used last two days will be returned.</param> 
        /// <returns>ApiResponse of FaxOutboundGetUpdatesCollectionResponseModel</returns>
        public ApiResponse< FaxOutboundGetUpdatesCollectionResponseModel > RetrieveFaxUpdatesWithHttpInfo (string lastPointer = null)
        {
            
    
            var path_ = "/v1/fax/outbound/updates";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            
            if (lastPointer != null) queryParams.Add("last_pointer", Configuration.ApiClient.ParameterToString(lastPointer)); // query parameter
            
            
            
            

            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            
    
            // make the HTTP request
            IRestResponse response = (IRestResponse) Configuration.ApiClient.CallApi(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams,
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
    
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling RetrieveFaxUpdates: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling RetrieveFaxUpdates: " + response.ErrorMessage, response.ErrorMessage);
    
            return new ApiResponse<FaxOutboundGetUpdatesCollectionResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (FaxOutboundGetUpdatesCollectionResponseModel) Configuration.ApiClient.Deserialize(response, typeof(FaxOutboundGetUpdatesCollectionResponseModel)));
            
        }
    
        /// <summary>
        /// Get fax submission status updates Retrieve any status updates for fax submissions since last checked.
        /// </summary>
        /// <param name="lastPointer">Optional pointer, if not used last two days will be returned.</param>
        /// <returns>Task of FaxOutboundGetUpdatesCollectionResponseModel</returns>
        public async System.Threading.Tasks.Task<FaxOutboundGetUpdatesCollectionResponseModel> RetrieveFaxUpdatesAsync (string lastPointer = null)
        {
             ApiResponse<FaxOutboundGetUpdatesCollectionResponseModel> response = await RetrieveFaxUpdatesAsyncWithHttpInfo(lastPointer);
             return response.Data;

        }

        /// <summary>
        /// Get fax submission status updates Retrieve any status updates for fax submissions since last checked.
        /// </summary>
        /// <param name="lastPointer">Optional pointer, if not used last two days will be returned.</param>
        /// <returns>Task of ApiResponse (FaxOutboundGetUpdatesCollectionResponseModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<FaxOutboundGetUpdatesCollectionResponseModel>> RetrieveFaxUpdatesAsyncWithHttpInfo (string lastPointer = null)
        {
            
    
            var path_ = "/v1/fax/outbound/updates";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>();
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            
            if (lastPointer != null) queryParams.Add("last_pointer", Configuration.ApiClient.ParameterToString(lastPointer)); // query parameter
            
            
            
            

            
            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            

            // make the HTTP request
            IRestResponse response = (IRestResponse) await Configuration.ApiClient.CallApiAsync(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams, 
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
 
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling RetrieveFaxUpdates: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling RetrieveFaxUpdates: " + response.ErrorMessage, response.ErrorMessage);

            return new ApiResponse<FaxOutboundGetUpdatesCollectionResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (FaxOutboundGetUpdatesCollectionResponseModel) Configuration.ApiClient.Deserialize(response, typeof(FaxOutboundGetUpdatesCollectionResponseModel)));
            
        }
        
        /// <summary>
        /// Check the status of a submitted fax. Returns the status of the fax submission referenced by the passed Id
        /// </summary>
        /// <param name="id">Id of message to check as provided on submission of Fax.</param> 
        /// <returns>FaxOutboundGetStatusResponseModel</returns>
        public FaxOutboundGetStatusResponseModel RetrieveFaxStatus (string id)
        {
             ApiResponse<FaxOutboundGetStatusResponseModel> response = RetrieveFaxStatusWithHttpInfo(id);
             return response.Data;
        }

        /// <summary>
        /// Check the status of a submitted fax. Returns the status of the fax submission referenced by the passed Id
        /// </summary>
        /// <param name="id">Id of message to check as provided on submission of Fax.</param> 
        /// <returns>ApiResponse of FaxOutboundGetStatusResponseModel</returns>
        public ApiResponse< FaxOutboundGetStatusResponseModel > RetrieveFaxStatusWithHttpInfo (string id)
        {
            
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling VApi->RetrieveFaxStatus");
            
    
            var path_ = "/v1/fax/outbound/{id}/status";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (id != null) pathParams.Add("id", Configuration.ApiClient.ParameterToString(id)); // path parameter
            
            
            
            
            

            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            
    
            // make the HTTP request
            IRestResponse response = (IRestResponse) Configuration.ApiClient.CallApi(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams,
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
    
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling RetrieveFaxStatus: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling RetrieveFaxStatus: " + response.ErrorMessage, response.ErrorMessage);
    
            return new ApiResponse<FaxOutboundGetStatusResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (FaxOutboundGetStatusResponseModel) Configuration.ApiClient.Deserialize(response, typeof(FaxOutboundGetStatusResponseModel)));
            
        }
    
        /// <summary>
        /// Check the status of a submitted fax. Returns the status of the fax submission referenced by the passed Id
        /// </summary>
        /// <param name="id">Id of message to check as provided on submission of Fax.</param>
        /// <returns>Task of FaxOutboundGetStatusResponseModel</returns>
        public async System.Threading.Tasks.Task<FaxOutboundGetStatusResponseModel> RetrieveFaxStatusAsync (string id)
        {
             ApiResponse<FaxOutboundGetStatusResponseModel> response = await RetrieveFaxStatusAsyncWithHttpInfo(id);
             return response.Data;

        }

        /// <summary>
        /// Check the status of a submitted fax. Returns the status of the fax submission referenced by the passed Id
        /// </summary>
        /// <param name="id">Id of message to check as provided on submission of Fax.</param>
        /// <returns>Task of ApiResponse (FaxOutboundGetStatusResponseModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<FaxOutboundGetStatusResponseModel>> RetrieveFaxStatusAsyncWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null) throw new ApiException(400, "Missing required parameter 'id' when calling RetrieveFaxStatus");
            
    
            var path_ = "/v1/fax/outbound/{id}/status";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>();
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (id != null) pathParams.Add("id", Configuration.ApiClient.ParameterToString(id)); // path parameter
            
            
            
            
            

            
            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            

            // make the HTTP request
            IRestResponse response = (IRestResponse) await Configuration.ApiClient.CallApiAsync(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams, 
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
 
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling RetrieveFaxStatus: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling RetrieveFaxStatus: " + response.ErrorMessage, response.ErrorMessage);

            return new ApiResponse<FaxOutboundGetStatusResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (FaxOutboundGetStatusResponseModel) Configuration.ApiClient.Deserialize(response, typeof(FaxOutboundGetStatusResponseModel)));
            
        }
        
        /// <summary>
        /// Get E.164 format number Provides an E.164 formatted (e.g. +441514962245) version of the provided national (e.g. 01514962245) format phone number
        /// </summary>
        /// <param name="number">National format phone number (e.g. 01514962245).</param> 
        /// <param name="location">Two letter country code matching the location the provided number is formatted for (e.g. US).</param> 
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. +44 151 496 2245).</param> 
        /// <returns>NumberFormatterResponseModel</returns>
        public NumberFormatterResponseModel FormatE164 (string number, string location, string pretty = null)
        {
             ApiResponse<NumberFormatterResponseModel> response = FormatE164WithHttpInfo(number, location, pretty);
             return response.Data;
        }

        /// <summary>
        /// Get E.164 format number Provides an E.164 formatted (e.g. +441514962245) version of the provided national (e.g. 01514962245) format phone number
        /// </summary>
        /// <param name="number">National format phone number (e.g. 01514962245).</param> 
        /// <param name="location">Two letter country code matching the location the provided number is formatted for (e.g. US).</param> 
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. +44 151 496 2245).</param> 
        /// <returns>ApiResponse of NumberFormatterResponseModel</returns>
        public ApiResponse< NumberFormatterResponseModel > FormatE164WithHttpInfo (string number, string location, string pretty = null)
        {
            
            // verify the required parameter 'number' is set
            if (number == null)
                throw new ApiException(400, "Missing required parameter 'number' when calling VApi->FormatE164");
            
            // verify the required parameter 'location' is set
            if (location == null)
                throw new ApiException(400, "Missing required parameter 'location' when calling VApi->FormatE164");
            
    
            var path_ = "/v1/format/number/e164/{number}/{location}";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (number != null) pathParams.Add("number", Configuration.ApiClient.ParameterToString(number)); // path parameter
            if (location != null) pathParams.Add("location", Configuration.ApiClient.ParameterToString(location)); // path parameter
            
            if (pretty != null) queryParams.Add("pretty", Configuration.ApiClient.ParameterToString(pretty)); // query parameter
            
            
            
            

            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            
    
            // make the HTTP request
            IRestResponse response = (IRestResponse) Configuration.ApiClient.CallApi(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams,
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
    
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling FormatE164: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling FormatE164: " + response.ErrorMessage, response.ErrorMessage);
    
            return new ApiResponse<NumberFormatterResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (NumberFormatterResponseModel) Configuration.ApiClient.Deserialize(response, typeof(NumberFormatterResponseModel)));
            
        }
    
        /// <summary>
        /// Get E.164 format number Provides an E.164 formatted (e.g. +441514962245) version of the provided national (e.g. 01514962245) format phone number
        /// </summary>
        /// <param name="number">National format phone number (e.g. 01514962245).</param>
        /// <param name="location">Two letter country code matching the location the provided number is formatted for (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. +44 151 496 2245).</param>
        /// <returns>Task of NumberFormatterResponseModel</returns>
        public async System.Threading.Tasks.Task<NumberFormatterResponseModel> FormatE164Async (string number, string location, string pretty = null)
        {
             ApiResponse<NumberFormatterResponseModel> response = await FormatE164AsyncWithHttpInfo(number, location, pretty);
             return response.Data;

        }

        /// <summary>
        /// Get E.164 format number Provides an E.164 formatted (e.g. +441514962245) version of the provided national (e.g. 01514962245) format phone number
        /// </summary>
        /// <param name="number">National format phone number (e.g. 01514962245).</param>
        /// <param name="location">Two letter country code matching the location the provided number is formatted for (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. +44 151 496 2245).</param>
        /// <returns>Task of ApiResponse (NumberFormatterResponseModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<NumberFormatterResponseModel>> FormatE164AsyncWithHttpInfo (string number, string location, string pretty = null)
        {
            // verify the required parameter 'number' is set
            if (number == null) throw new ApiException(400, "Missing required parameter 'number' when calling FormatE164");
            // verify the required parameter 'location' is set
            if (location == null) throw new ApiException(400, "Missing required parameter 'location' when calling FormatE164");
            
    
            var path_ = "/v1/format/number/e164/{number}/{location}";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>();
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (number != null) pathParams.Add("number", Configuration.ApiClient.ParameterToString(number)); // path parameter
            if (location != null) pathParams.Add("location", Configuration.ApiClient.ParameterToString(location)); // path parameter
            
            if (pretty != null) queryParams.Add("pretty", Configuration.ApiClient.ParameterToString(pretty)); // query parameter
            
            
            
            

            
            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            

            // make the HTTP request
            IRestResponse response = (IRestResponse) await Configuration.ApiClient.CallApiAsync(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams, 
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
 
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling FormatE164: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling FormatE164: " + response.ErrorMessage, response.ErrorMessage);

            return new ApiResponse<NumberFormatterResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (NumberFormatterResponseModel) Configuration.ApiClient.Deserialize(response, typeof(NumberFormatterResponseModel)));
            
        }
        
        /// <summary>
        /// Get international format number Converts the provided National format number (e.g. 01514962245) into an dialable number in the provided location (e.g. 011441514962245 for dialing GB from US)
        /// </summary>
        /// <param name="number">Phone number in National format (e.g. 01514962245).</param> 
        /// <param name="providedLocation">Two letter country code matching provided number format (e.g. GB).</param> 
        /// <param name="dialFromLocation">Two letter country code of location dialling from (e.g. US).</param> 
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 011 44 151 496 2245).</param> 
        /// <returns>NumberFormatterResponseModel</returns>
        public NumberFormatterResponseModel FormatInternational (string number, string providedLocation, string dialFromLocation, string pretty = null)
        {
             ApiResponse<NumberFormatterResponseModel> response = FormatInternationalWithHttpInfo(number, providedLocation, dialFromLocation, pretty);
             return response.Data;
        }

        /// <summary>
        /// Get international format number Converts the provided National format number (e.g. 01514962245) into an dialable number in the provided location (e.g. 011441514962245 for dialing GB from US)
        /// </summary>
        /// <param name="number">Phone number in National format (e.g. 01514962245).</param> 
        /// <param name="providedLocation">Two letter country code matching provided number format (e.g. GB).</param> 
        /// <param name="dialFromLocation">Two letter country code of location dialling from (e.g. US).</param> 
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 011 44 151 496 2245).</param> 
        /// <returns>ApiResponse of NumberFormatterResponseModel</returns>
        public ApiResponse< NumberFormatterResponseModel > FormatInternationalWithHttpInfo (string number, string providedLocation, string dialFromLocation, string pretty = null)
        {
            
            // verify the required parameter 'number' is set
            if (number == null)
                throw new ApiException(400, "Missing required parameter 'number' when calling VApi->FormatInternational");
            
            // verify the required parameter 'providedLocation' is set
            if (providedLocation == null)
                throw new ApiException(400, "Missing required parameter 'providedLocation' when calling VApi->FormatInternational");
            
            // verify the required parameter 'dialFromLocation' is set
            if (dialFromLocation == null)
                throw new ApiException(400, "Missing required parameter 'dialFromLocation' when calling VApi->FormatInternational");
            
    
            var path_ = "/v1/format/number/international/{number}/{providedLocation}/{dialFromLocation}";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (number != null) pathParams.Add("number", Configuration.ApiClient.ParameterToString(number)); // path parameter
            if (providedLocation != null) pathParams.Add("providedLocation", Configuration.ApiClient.ParameterToString(providedLocation)); // path parameter
            if (dialFromLocation != null) pathParams.Add("dialFromLocation", Configuration.ApiClient.ParameterToString(dialFromLocation)); // path parameter
            
            if (pretty != null) queryParams.Add("pretty", Configuration.ApiClient.ParameterToString(pretty)); // query parameter
            
            
            
            

            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            
    
            // make the HTTP request
            IRestResponse response = (IRestResponse) Configuration.ApiClient.CallApi(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams,
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
    
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling FormatInternational: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling FormatInternational: " + response.ErrorMessage, response.ErrorMessage);
    
            return new ApiResponse<NumberFormatterResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (NumberFormatterResponseModel) Configuration.ApiClient.Deserialize(response, typeof(NumberFormatterResponseModel)));
            
        }
    
        /// <summary>
        /// Get international format number Converts the provided National format number (e.g. 01514962245) into an dialable number in the provided location (e.g. 011441514962245 for dialing GB from US)
        /// </summary>
        /// <param name="number">Phone number in National format (e.g. 01514962245).</param>
        /// <param name="providedLocation">Two letter country code matching provided number format (e.g. GB).</param>
        /// <param name="dialFromLocation">Two letter country code of location dialling from (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 011 44 151 496 2245).</param>
        /// <returns>Task of NumberFormatterResponseModel</returns>
        public async System.Threading.Tasks.Task<NumberFormatterResponseModel> FormatInternationalAsync (string number, string providedLocation, string dialFromLocation, string pretty = null)
        {
             ApiResponse<NumberFormatterResponseModel> response = await FormatInternationalAsyncWithHttpInfo(number, providedLocation, dialFromLocation, pretty);
             return response.Data;

        }

        /// <summary>
        /// Get international format number Converts the provided National format number (e.g. 01514962245) into an dialable number in the provided location (e.g. 011441514962245 for dialing GB from US)
        /// </summary>
        /// <param name="number">Phone number in National format (e.g. 01514962245).</param>
        /// <param name="providedLocation">Two letter country code matching provided number format (e.g. GB).</param>
        /// <param name="dialFromLocation">Two letter country code of location dialling from (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 011 44 151 496 2245).</param>
        /// <returns>Task of ApiResponse (NumberFormatterResponseModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<NumberFormatterResponseModel>> FormatInternationalAsyncWithHttpInfo (string number, string providedLocation, string dialFromLocation, string pretty = null)
        {
            // verify the required parameter 'number' is set
            if (number == null) throw new ApiException(400, "Missing required parameter 'number' when calling FormatInternational");
            // verify the required parameter 'providedLocation' is set
            if (providedLocation == null) throw new ApiException(400, "Missing required parameter 'providedLocation' when calling FormatInternational");
            // verify the required parameter 'dialFromLocation' is set
            if (dialFromLocation == null) throw new ApiException(400, "Missing required parameter 'dialFromLocation' when calling FormatInternational");
            
    
            var path_ = "/v1/format/number/international/{number}/{providedLocation}/{dialFromLocation}";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>();
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (number != null) pathParams.Add("number", Configuration.ApiClient.ParameterToString(number)); // path parameter
            if (providedLocation != null) pathParams.Add("providedLocation", Configuration.ApiClient.ParameterToString(providedLocation)); // path parameter
            if (dialFromLocation != null) pathParams.Add("dialFromLocation", Configuration.ApiClient.ParameterToString(dialFromLocation)); // path parameter
            
            if (pretty != null) queryParams.Add("pretty", Configuration.ApiClient.ParameterToString(pretty)); // query parameter
            
            
            
            

            
            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            

            // make the HTTP request
            IRestResponse response = (IRestResponse) await Configuration.ApiClient.CallApiAsync(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams, 
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
 
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling FormatInternational: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling FormatInternational: " + response.ErrorMessage, response.ErrorMessage);

            return new ApiResponse<NumberFormatterResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (NumberFormatterResponseModel) Configuration.ApiClient.Deserialize(response, typeof(NumberFormatterResponseModel)));
            
        }
        
        /// <summary>
        /// Get national format number Provides the national (e.g. 01514962245) format variant of the provided E.164 (e.g. +441514962245)
        /// </summary>
        /// <param name="number">Phone number in E.164 format (e.g. +441514962245).</param> 
        /// <param name="location">Two letter country code (e.g. US).</param> 
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 0151 496 2245).</param> 
        /// <returns>NumberFormatterResponseModel</returns>
        public NumberFormatterResponseModel FormatNational (string number, string location, string pretty = null)
        {
             ApiResponse<NumberFormatterResponseModel> response = FormatNationalWithHttpInfo(number, location, pretty);
             return response.Data;
        }

        /// <summary>
        /// Get national format number Provides the national (e.g. 01514962245) format variant of the provided E.164 (e.g. +441514962245)
        /// </summary>
        /// <param name="number">Phone number in E.164 format (e.g. +441514962245).</param> 
        /// <param name="location">Two letter country code (e.g. US).</param> 
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 0151 496 2245).</param> 
        /// <returns>ApiResponse of NumberFormatterResponseModel</returns>
        public ApiResponse< NumberFormatterResponseModel > FormatNationalWithHttpInfo (string number, string location, string pretty = null)
        {
            
            // verify the required parameter 'number' is set
            if (number == null)
                throw new ApiException(400, "Missing required parameter 'number' when calling VApi->FormatNational");
            
            // verify the required parameter 'location' is set
            if (location == null)
                throw new ApiException(400, "Missing required parameter 'location' when calling VApi->FormatNational");
            
    
            var path_ = "/v1/format/number/national/{number}/{location}";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (number != null) pathParams.Add("number", Configuration.ApiClient.ParameterToString(number)); // path parameter
            if (location != null) pathParams.Add("location", Configuration.ApiClient.ParameterToString(location)); // path parameter
            
            if (pretty != null) queryParams.Add("pretty", Configuration.ApiClient.ParameterToString(pretty)); // query parameter
            
            
            
            

            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            
    
            // make the HTTP request
            IRestResponse response = (IRestResponse) Configuration.ApiClient.CallApi(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams,
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
    
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling FormatNational: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling FormatNational: " + response.ErrorMessage, response.ErrorMessage);
    
            return new ApiResponse<NumberFormatterResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (NumberFormatterResponseModel) Configuration.ApiClient.Deserialize(response, typeof(NumberFormatterResponseModel)));
            
        }
    
        /// <summary>
        /// Get national format number Provides the national (e.g. 01514962245) format variant of the provided E.164 (e.g. +441514962245)
        /// </summary>
        /// <param name="number">Phone number in E.164 format (e.g. +441514962245).</param>
        /// <param name="location">Two letter country code (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 0151 496 2245).</param>
        /// <returns>Task of NumberFormatterResponseModel</returns>
        public async System.Threading.Tasks.Task<NumberFormatterResponseModel> FormatNationalAsync (string number, string location, string pretty = null)
        {
             ApiResponse<NumberFormatterResponseModel> response = await FormatNationalAsyncWithHttpInfo(number, location, pretty);
             return response.Data;

        }

        /// <summary>
        /// Get national format number Provides the national (e.g. 01514962245) format variant of the provided E.164 (e.g. +441514962245)
        /// </summary>
        /// <param name="number">Phone number in E.164 format (e.g. +441514962245).</param>
        /// <param name="location">Two letter country code (e.g. US).</param>
        /// <param name="pretty">Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 0151 496 2245).</param>
        /// <returns>Task of ApiResponse (NumberFormatterResponseModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<NumberFormatterResponseModel>> FormatNationalAsyncWithHttpInfo (string number, string location, string pretty = null)
        {
            // verify the required parameter 'number' is set
            if (number == null) throw new ApiException(400, "Missing required parameter 'number' when calling FormatNational");
            // verify the required parameter 'location' is set
            if (location == null) throw new ApiException(400, "Missing required parameter 'location' when calling FormatNational");
            
    
            var path_ = "/v1/format/number/national/{number}/{location}";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>();
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (number != null) pathParams.Add("number", Configuration.ApiClient.ParameterToString(number)); // path parameter
            if (location != null) pathParams.Add("location", Configuration.ApiClient.ParameterToString(location)); // path parameter
            
            if (pretty != null) queryParams.Add("pretty", Configuration.ApiClient.ParameterToString(pretty)); // query parameter
            
            
            
            

            
            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            

            // make the HTTP request
            IRestResponse response = (IRestResponse) await Configuration.ApiClient.CallApiAsync(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams, 
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
 
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling FormatNational: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling FormatNational: " + response.ErrorMessage, response.ErrorMessage);

            return new ApiResponse<NumberFormatterResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (NumberFormatterResponseModel) Configuration.ApiClient.Deserialize(response, typeof(NumberFormatterResponseModel)));
            
        }
        
        /// <summary>
        /// Get pretty number Uses whitespace to provide human readable numbers
        /// </summary>
        /// <param name="number">Phone number to format (e.g. 01514962245, 011441514962245, +441514962245).</param> 
        /// <param name="location">Two letter country code matching provided number format (e.g. GB).</param> 
        /// <returns>NumberFormatterResponseModel</returns>
        public NumberFormatterResponseModel FormatPretty (string number, string location)
        {
             ApiResponse<NumberFormatterResponseModel> response = FormatPrettyWithHttpInfo(number, location);
             return response.Data;
        }

        /// <summary>
        /// Get pretty number Uses whitespace to provide human readable numbers
        /// </summary>
        /// <param name="number">Phone number to format (e.g. 01514962245, 011441514962245, +441514962245).</param> 
        /// <param name="location">Two letter country code matching provided number format (e.g. GB).</param> 
        /// <returns>ApiResponse of NumberFormatterResponseModel</returns>
        public ApiResponse< NumberFormatterResponseModel > FormatPrettyWithHttpInfo (string number, string location)
        {
            
            // verify the required parameter 'number' is set
            if (number == null)
                throw new ApiException(400, "Missing required parameter 'number' when calling VApi->FormatPretty");
            
            // verify the required parameter 'location' is set
            if (location == null)
                throw new ApiException(400, "Missing required parameter 'location' when calling VApi->FormatPretty");
            
    
            var path_ = "/v1/format/number/pretty/{number}/{location}";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (number != null) pathParams.Add("number", Configuration.ApiClient.ParameterToString(number)); // path parameter
            if (location != null) pathParams.Add("location", Configuration.ApiClient.ParameterToString(location)); // path parameter
            
            
            
            
            

            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            
    
            // make the HTTP request
            IRestResponse response = (IRestResponse) Configuration.ApiClient.CallApi(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams,
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
    
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling FormatPretty: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling FormatPretty: " + response.ErrorMessage, response.ErrorMessage);
    
            return new ApiResponse<NumberFormatterResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (NumberFormatterResponseModel) Configuration.ApiClient.Deserialize(response, typeof(NumberFormatterResponseModel)));
            
        }
    
        /// <summary>
        /// Get pretty number Uses whitespace to provide human readable numbers
        /// </summary>
        /// <param name="number">Phone number to format (e.g. 01514962245, 011441514962245, +441514962245).</param>
        /// <param name="location">Two letter country code matching provided number format (e.g. GB).</param>
        /// <returns>Task of NumberFormatterResponseModel</returns>
        public async System.Threading.Tasks.Task<NumberFormatterResponseModel> FormatPrettyAsync (string number, string location)
        {
             ApiResponse<NumberFormatterResponseModel> response = await FormatPrettyAsyncWithHttpInfo(number, location);
             return response.Data;

        }

        /// <summary>
        /// Get pretty number Uses whitespace to provide human readable numbers
        /// </summary>
        /// <param name="number">Phone number to format (e.g. 01514962245, 011441514962245, +441514962245).</param>
        /// <param name="location">Two letter country code matching provided number format (e.g. GB).</param>
        /// <returns>Task of ApiResponse (NumberFormatterResponseModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<NumberFormatterResponseModel>> FormatPrettyAsyncWithHttpInfo (string number, string location)
        {
            // verify the required parameter 'number' is set
            if (number == null) throw new ApiException(400, "Missing required parameter 'number' when calling FormatPretty");
            // verify the required parameter 'location' is set
            if (location == null) throw new ApiException(400, "Missing required parameter 'location' when calling FormatPretty");
            
    
            var path_ = "/v1/format/number/pretty/{number}/{location}";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>();
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (number != null) pathParams.Add("number", Configuration.ApiClient.ParameterToString(number)); // path parameter
            if (location != null) pathParams.Add("location", Configuration.ApiClient.ParameterToString(location)); // path parameter
            
            
            
            
            

            
            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            

            // make the HTTP request
            IRestResponse response = (IRestResponse) await Configuration.ApiClient.CallApiAsync(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams, 
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
 
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling FormatPretty: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling FormatPretty: " + response.ErrorMessage, response.ErrorMessage);

            return new ApiResponse<NumberFormatterResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (NumberFormatterResponseModel) Configuration.ApiClient.Deserialize(response, typeof(NumberFormatterResponseModel)));
            
        }
        
        /// <summary>
        ///  Retrieve locality info
        /// </summary>
        /// <param name="phoneNumber">Phone number</param> 
        /// <returns>LocalityInfoResponseModel</returns>
        public LocalityInfoResponseModel RetrieveLocalityInfo (string phoneNumber)
        {
             ApiResponse<LocalityInfoResponseModel> response = RetrieveLocalityInfoWithHttpInfo(phoneNumber);
             return response.Data;
        }

        /// <summary>
        ///  Retrieve locality info
        /// </summary>
        /// <param name="phoneNumber">Phone number</param> 
        /// <returns>ApiResponse of LocalityInfoResponseModel</returns>
        public ApiResponse< LocalityInfoResponseModel > RetrieveLocalityInfoWithHttpInfo (string phoneNumber)
        {
            
            // verify the required parameter 'phoneNumber' is set
            if (phoneNumber == null)
                throw new ApiException(400, "Missing required parameter 'phoneNumber' when calling VApi->RetrieveLocalityInfo");
            
    
            var path_ = "/v1/locality-lookup/{phoneNumber}";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (phoneNumber != null) pathParams.Add("phoneNumber", Configuration.ApiClient.ParameterToString(phoneNumber)); // path parameter
            
            
            
            
            

            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            
    
            // make the HTTP request
            IRestResponse response = (IRestResponse) Configuration.ApiClient.CallApi(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams,
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
    
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling RetrieveLocalityInfo: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling RetrieveLocalityInfo: " + response.ErrorMessage, response.ErrorMessage);
    
            return new ApiResponse<LocalityInfoResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (LocalityInfoResponseModel) Configuration.ApiClient.Deserialize(response, typeof(LocalityInfoResponseModel)));
            
        }
    
        /// <summary>
        ///  Retrieve locality info
        /// </summary>
        /// <param name="phoneNumber">Phone number</param>
        /// <returns>Task of LocalityInfoResponseModel</returns>
        public async System.Threading.Tasks.Task<LocalityInfoResponseModel> RetrieveLocalityInfoAsync (string phoneNumber)
        {
             ApiResponse<LocalityInfoResponseModel> response = await RetrieveLocalityInfoAsyncWithHttpInfo(phoneNumber);
             return response.Data;

        }

        /// <summary>
        ///  Retrieve locality info
        /// </summary>
        /// <param name="phoneNumber">Phone number</param>
        /// <returns>Task of ApiResponse (LocalityInfoResponseModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<LocalityInfoResponseModel>> RetrieveLocalityInfoAsyncWithHttpInfo (string phoneNumber)
        {
            // verify the required parameter 'phoneNumber' is set
            if (phoneNumber == null) throw new ApiException(400, "Missing required parameter 'phoneNumber' when calling RetrieveLocalityInfo");
            
    
            var path_ = "/v1/locality-lookup/{phoneNumber}";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>();
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (phoneNumber != null) pathParams.Add("phoneNumber", Configuration.ApiClient.ParameterToString(phoneNumber)); // path parameter
            
            
            
            
            

            
            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            

            // make the HTTP request
            IRestResponse response = (IRestResponse) await Configuration.ApiClient.CallApiAsync(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams, 
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
 
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling RetrieveLocalityInfo: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling RetrieveLocalityInfo: " + response.ErrorMessage, response.ErrorMessage);

            return new ApiResponse<LocalityInfoResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (LocalityInfoResponseModel) Configuration.ApiClient.Deserialize(response, typeof(LocalityInfoResponseModel)));
            
        }
        
        /// <summary>
        /// Check Telephone Preference Service Check if provided number is included in the Telephony Preference Service list. Returns true or false.
        /// </summary>
        /// <param name="phoneNumber">Phone number to lookup in E.164 format or national format according to numberFormatLocation.</param> 
        /// <param name="numberFormatLocation">Optional; ISO 3166-1 alpha-2 Two letter country code matching the origin of the provided number format, defaults to GB.</param> 
        /// <returns></returns>
        public void RetrieveTps (string phoneNumber, string numberFormatLocation = null)
        {
             RetrieveTpsWithHttpInfo(phoneNumber, numberFormatLocation);
        }

        /// <summary>
        /// Check Telephone Preference Service Check if provided number is included in the Telephony Preference Service list. Returns true or false.
        /// </summary>
        /// <param name="phoneNumber">Phone number to lookup in E.164 format or national format according to numberFormatLocation.</param> 
        /// <param name="numberFormatLocation">Optional; ISO 3166-1 alpha-2 Two letter country code matching the origin of the provided number format, defaults to GB.</param> 
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> RetrieveTpsWithHttpInfo (string phoneNumber, string numberFormatLocation = null)
        {
            
            // verify the required parameter 'phoneNumber' is set
            if (phoneNumber == null)
                throw new ApiException(400, "Missing required parameter 'phoneNumber' when calling VApi->RetrieveTps");
            
    
            var path_ = "/v1/recipient-preferences/tps/{phone_number}";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (phoneNumber != null) pathParams.Add("phone_number", Configuration.ApiClient.ParameterToString(phoneNumber)); // path parameter
            
            if (numberFormatLocation != null) queryParams.Add("numberFormatLocation", Configuration.ApiClient.ParameterToString(numberFormatLocation)); // query parameter
            
            
            
            

            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            
    
            // make the HTTP request
            IRestResponse response = (IRestResponse) Configuration.ApiClient.CallApi(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams,
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
    
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling RetrieveTps: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling RetrieveTps: " + response.ErrorMessage, response.ErrorMessage);
    
            
            return new ApiResponse<Object>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }
    
        /// <summary>
        /// Check Telephone Preference Service Check if provided number is included in the Telephony Preference Service list. Returns true or false.
        /// </summary>
        /// <param name="phoneNumber">Phone number to lookup in E.164 format or national format according to numberFormatLocation.</param>
        /// <param name="numberFormatLocation">Optional; ISO 3166-1 alpha-2 Two letter country code matching the origin of the provided number format, defaults to GB.</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task RetrieveTpsAsync (string phoneNumber, string numberFormatLocation = null)
        {
             await RetrieveTpsAsyncWithHttpInfo(phoneNumber, numberFormatLocation);

        }

        /// <summary>
        /// Check Telephone Preference Service Check if provided number is included in the Telephony Preference Service list. Returns true or false.
        /// </summary>
        /// <param name="phoneNumber">Phone number to lookup in E.164 format or national format according to numberFormatLocation.</param>
        /// <param name="numberFormatLocation">Optional; ISO 3166-1 alpha-2 Two letter country code matching the origin of the provided number format, defaults to GB.</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> RetrieveTpsAsyncWithHttpInfo (string phoneNumber, string numberFormatLocation = null)
        {
            // verify the required parameter 'phoneNumber' is set
            if (phoneNumber == null) throw new ApiException(400, "Missing required parameter 'phoneNumber' when calling RetrieveTps");
            
    
            var path_ = "/v1/recipient-preferences/tps/{phone_number}";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>();
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (phoneNumber != null) pathParams.Add("phone_number", Configuration.ApiClient.ParameterToString(phoneNumber)); // path parameter
            
            if (numberFormatLocation != null) queryParams.Add("numberFormatLocation", Configuration.ApiClient.ParameterToString(numberFormatLocation)); // query parameter
            
            
            
            

            
            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            

            // make the HTTP request
            IRestResponse response = (IRestResponse) await Configuration.ApiClient.CallApiAsync(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams, 
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
 
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling RetrieveTps: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling RetrieveTps: " + response.ErrorMessage, response.ErrorMessage);

            
            return new ApiResponse<Object>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }
        
        /// <summary>
        /// Send an SMS Text Message Send an SMS message from one of your TC numbers, or the default number (this can be found on the API Access settings on the TelecomsCloud website). SMS message is queued for delivery to the specified recipient, returning a unique reference on success. This reference can be used to check the status of the submitted message.
        /// </summary>
        /// <param name="smsOutboundSendResponseModel">* to : string (required) - Number to send message to.  * from : string (required) - Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading &#39;+&#39;) or UK based number formatting by default.  * message : string (required) - Message to send to recipient, up to 160 chars.  * numberFormatLocation : string - Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.</param> 
        /// <returns>SmsOutboundSendResponseModel</returns>
        public SmsOutboundSendResponseModel SendSms (SmsOutboundSendResponseModel smsOutboundSendResponseModel)
        {
             ApiResponse<SmsOutboundSendResponseModel> response = SendSmsWithHttpInfo(smsOutboundSendResponseModel);
             return response.Data;
        }

        /// <summary>
        /// Send an SMS Text Message Send an SMS message from one of your TC numbers, or the default number (this can be found on the API Access settings on the TelecomsCloud website). SMS message is queued for delivery to the specified recipient, returning a unique reference on success. This reference can be used to check the status of the submitted message.
        /// </summary>
        /// <param name="smsOutboundSendResponseModel">* to : string (required) - Number to send message to.  * from : string (required) - Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading &#39;+&#39;) or UK based number formatting by default.  * message : string (required) - Message to send to recipient, up to 160 chars.  * numberFormatLocation : string - Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.</param> 
        /// <returns>ApiResponse of SmsOutboundSendResponseModel</returns>
        public ApiResponse< SmsOutboundSendResponseModel > SendSmsWithHttpInfo (SmsOutboundSendResponseModel smsOutboundSendResponseModel)
        {
            
            // verify the required parameter 'smsOutboundSendResponseModel' is set
            if (smsOutboundSendResponseModel == null)
                throw new ApiException(400, "Missing required parameter 'smsOutboundSendResponseModel' when calling VApi->SendSms");
            
    
            var path_ = "/v1/sms/outbound";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                "application/json"
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            
            
            
            
            if (smsOutboundSendResponseModel.GetType() != typeof(byte[]))
            {
                postBody = Configuration.ApiClient.Serialize(smsOutboundSendResponseModel); // http body (model) parameter
            }
            else
            {
                postBody = smsOutboundSendResponseModel; // byte array
            }

            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            
    
            // make the HTTP request
            IRestResponse response = (IRestResponse) Configuration.ApiClient.CallApi(path_, 
                Method.POST, queryParams, postBody, headerParams, formParams, fileParams,
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
    
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling SendSms: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling SendSms: " + response.ErrorMessage, response.ErrorMessage);
    
            return new ApiResponse<SmsOutboundSendResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SmsOutboundSendResponseModel) Configuration.ApiClient.Deserialize(response, typeof(SmsOutboundSendResponseModel)));
            
        }
    
        /// <summary>
        /// Send an SMS Text Message Send an SMS message from one of your TC numbers, or the default number (this can be found on the API Access settings on the TelecomsCloud website). SMS message is queued for delivery to the specified recipient, returning a unique reference on success. This reference can be used to check the status of the submitted message.
        /// </summary>
        /// <param name="smsOutboundSendResponseModel">* to : string (required) - Number to send message to.  * from : string (required) - Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading &#39;+&#39;) or UK based number formatting by default.  * message : string (required) - Message to send to recipient, up to 160 chars.  * numberFormatLocation : string - Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.</param>
        /// <returns>Task of SmsOutboundSendResponseModel</returns>
        public async System.Threading.Tasks.Task<SmsOutboundSendResponseModel> SendSmsAsync (SmsOutboundSendResponseModel smsOutboundSendResponseModel)
        {
             ApiResponse<SmsOutboundSendResponseModel> response = await SendSmsAsyncWithHttpInfo(smsOutboundSendResponseModel);
             return response.Data;

        }

        /// <summary>
        /// Send an SMS Text Message Send an SMS message from one of your TC numbers, or the default number (this can be found on the API Access settings on the TelecomsCloud website). SMS message is queued for delivery to the specified recipient, returning a unique reference on success. This reference can be used to check the status of the submitted message.
        /// </summary>
        /// <param name="smsOutboundSendResponseModel">* to : string (required) - Number to send message to.  * from : string (required) - Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading &#39;+&#39;) or UK based number formatting by default.  * message : string (required) - Message to send to recipient, up to 160 chars.  * numberFormatLocation : string - Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.</param>
        /// <returns>Task of ApiResponse (SmsOutboundSendResponseModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SmsOutboundSendResponseModel>> SendSmsAsyncWithHttpInfo (SmsOutboundSendResponseModel smsOutboundSendResponseModel)
        {
            // verify the required parameter 'smsOutboundSendResponseModel' is set
            if (smsOutboundSendResponseModel == null) throw new ApiException(400, "Missing required parameter 'smsOutboundSendResponseModel' when calling SendSms");
            
    
            var path_ = "/v1/sms/outbound";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>();
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                "application/json"
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            
            
            
            
            postBody = Configuration.ApiClient.Serialize(smsOutboundSendResponseModel); // http body (model) parameter
            

            
            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            

            // make the HTTP request
            IRestResponse response = (IRestResponse) await Configuration.ApiClient.CallApiAsync(path_, 
                Method.POST, queryParams, postBody, headerParams, formParams, fileParams, 
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
 
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling SendSms: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling SendSms: " + response.ErrorMessage, response.ErrorMessage);

            return new ApiResponse<SmsOutboundSendResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SmsOutboundSendResponseModel) Configuration.ApiClient.Deserialize(response, typeof(SmsOutboundSendResponseModel)));
            
        }
        
        /// <summary>
        ///  Get sms status
        /// </summary>
        /// <param name="smsId">Sms ID</param> 
        /// <returns>SmsOutboundGetStatusResponseModel</returns>
        public SmsOutboundGetStatusResponseModel GetSmsStatus (string smsId)
        {
             ApiResponse<SmsOutboundGetStatusResponseModel> response = GetSmsStatusWithHttpInfo(smsId);
             return response.Data;
        }

        /// <summary>
        ///  Get sms status
        /// </summary>
        /// <param name="smsId">Sms ID</param> 
        /// <returns>ApiResponse of SmsOutboundGetStatusResponseModel</returns>
        public ApiResponse< SmsOutboundGetStatusResponseModel > GetSmsStatusWithHttpInfo (string smsId)
        {
            
            // verify the required parameter 'smsId' is set
            if (smsId == null)
                throw new ApiException(400, "Missing required parameter 'smsId' when calling VApi->GetSmsStatus");
            
    
            var path_ = "/v1/sms/outbound/{sms_id}/status";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (smsId != null) pathParams.Add("sms_id", Configuration.ApiClient.ParameterToString(smsId)); // path parameter
            
            
            
            
            

            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            
    
            // make the HTTP request
            IRestResponse response = (IRestResponse) Configuration.ApiClient.CallApi(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams,
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
    
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling GetSmsStatus: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling GetSmsStatus: " + response.ErrorMessage, response.ErrorMessage);
    
            return new ApiResponse<SmsOutboundGetStatusResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SmsOutboundGetStatusResponseModel) Configuration.ApiClient.Deserialize(response, typeof(SmsOutboundGetStatusResponseModel)));
            
        }
    
        /// <summary>
        ///  Get sms status
        /// </summary>
        /// <param name="smsId">Sms ID</param>
        /// <returns>Task of SmsOutboundGetStatusResponseModel</returns>
        public async System.Threading.Tasks.Task<SmsOutboundGetStatusResponseModel> GetSmsStatusAsync (string smsId)
        {
             ApiResponse<SmsOutboundGetStatusResponseModel> response = await GetSmsStatusAsyncWithHttpInfo(smsId);
             return response.Data;

        }

        /// <summary>
        ///  Get sms status
        /// </summary>
        /// <param name="smsId">Sms ID</param>
        /// <returns>Task of ApiResponse (SmsOutboundGetStatusResponseModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SmsOutboundGetStatusResponseModel>> GetSmsStatusAsyncWithHttpInfo (string smsId)
        {
            // verify the required parameter 'smsId' is set
            if (smsId == null) throw new ApiException(400, "Missing required parameter 'smsId' when calling GetSmsStatus");
            
    
            var path_ = "/v1/sms/outbound/{sms_id}/status";
    
            var pathParams = new Dictionary<String, String>();
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>();
            var formParams = new Dictionary<String, String>();
            var fileParams = new Dictionary<String, FileParameter>();
            Object postBody = null;

            // to determine the Content-Type header
            String[] httpContentTypes = new String[] {
                
            };
            String httpContentType = Configuration.ApiClient.SelectHeaderContentType(httpContentTypes);

            // to determine the Accept header
            String[] httpHeaderAccepts = new String[] {
                "application/json"
            };
            String httpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAccept != null)
                headerParams.Add("Accept", httpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            pathParams.Add("format", "json");
            if (smsId != null) pathParams.Add("sms_id", Configuration.ApiClient.ParameterToString(smsId)); // path parameter
            
            
            
            
            

            
            // authentication (Default) required
            
            // oauth required
            if (!String.IsNullOrEmpty(Configuration.AccessToken))
            {
                headerParams["Authorization"] = "Bearer " + Configuration.AccessToken;
            }
            

            // make the HTTP request
            IRestResponse response = (IRestResponse) await Configuration.ApiClient.CallApiAsync(path_, 
                Method.GET, queryParams, postBody, headerParams, formParams, fileParams, 
                pathParams, httpContentType);

            int statusCode = (int) response.StatusCode;
 
            if (statusCode >= 400)
                throw new ApiException (statusCode, "Error calling GetSmsStatus: " + response.Content, response.Content);
            else if (statusCode == 0)
                throw new ApiException (statusCode, "Error calling GetSmsStatus: " + response.ErrorMessage, response.ErrorMessage);

            return new ApiResponse<SmsOutboundGetStatusResponseModel>(statusCode,
                response.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SmsOutboundGetStatusResponseModel) Configuration.ApiClient.Deserialize(response, typeof(SmsOutboundGetStatusResponseModel)));
            
        }
        
    }
    
}
