using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace Com.Telecomscloud.Api.TelecomsCloud.Model
{

    /// <summary>
    /// Model for AccountInfoResponseModel
    /// </summary>
    [DataContract]
    public class AccountInfoResponseModel :  IEquatable<AccountInfoResponseModel>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AccountInfoResponseModel" /> class.
        /// </summary>
        public AccountInfoResponseModel()
        {
            
        }

        
        /// <summary>
        /// Gets or Sets ActiveServices
        /// </summary>
        [DataMember(Name="active_services", EmitDefaultValue=false)]
        public int? ActiveServices { get; set; }
  
        
        /// <summary>
        /// Gets or Sets CreditBalance
        /// </summary>
        [DataMember(Name="credit_balance", EmitDefaultValue=false)]
        public string CreditBalance { get; set; }
  
        
        /// <summary>
        /// Gets or Sets PrimaryEmail
        /// </summary>
        [DataMember(Name="primary_email", EmitDefaultValue=false)]
        public string PrimaryEmail { get; set; }
  
        
        /// <summary>
        /// Gets or Sets Status
        /// </summary>
        [DataMember(Name="status", EmitDefaultValue=false)]
        public string Status { get; set; }
  
        
        /// <summary>
        /// Gets or Sets Username
        /// </summary>
        [DataMember(Name="username", EmitDefaultValue=false)]
        public string Username { get; set; }
  
        
  
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class AccountInfoResponseModel {\n");
            sb.Append("  ActiveServices: ").Append(ActiveServices).Append("\n");
            sb.Append("  CreditBalance: ").Append(CreditBalance).Append("\n");
            sb.Append("  PrimaryEmail: ").Append(PrimaryEmail).Append("\n");
            sb.Append("  Status: ").Append(Status).Append("\n");
            sb.Append("  Username: ").Append(Username).Append("\n");
            
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as AccountInfoResponseModel);
        }

        /// <summary>
        /// Returns true if AccountInfoResponseModel instances are equal
        /// </summary>
        /// <param name="other">Instance of AccountInfoResponseModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(AccountInfoResponseModel other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.ActiveServices == other.ActiveServices ||
                    this.ActiveServices != null &&
                    this.ActiveServices.Equals(other.ActiveServices)
                ) && 
                (
                    this.CreditBalance == other.CreditBalance ||
                    this.CreditBalance != null &&
                    this.CreditBalance.Equals(other.CreditBalance)
                ) && 
                (
                    this.PrimaryEmail == other.PrimaryEmail ||
                    this.PrimaryEmail != null &&
                    this.PrimaryEmail.Equals(other.PrimaryEmail)
                ) && 
                (
                    this.Status == other.Status ||
                    this.Status != null &&
                    this.Status.Equals(other.Status)
                ) && 
                (
                    this.Username == other.Username ||
                    this.Username != null &&
                    this.Username.Equals(other.Username)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                
                if (this.ActiveServices != null)
                    hash = hash * 59 + this.ActiveServices.GetHashCode();
                
                if (this.CreditBalance != null)
                    hash = hash * 59 + this.CreditBalance.GetHashCode();
                
                if (this.PrimaryEmail != null)
                    hash = hash * 59 + this.PrimaryEmail.GetHashCode();
                
                if (this.Status != null)
                    hash = hash * 59 + this.Status.GetHashCode();
                
                if (this.Username != null)
                    hash = hash * 59 + this.Username.GetHashCode();
                
                return hash;
            }
        }

    }
}
