using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace Com.Telecomscloud.Api.TelecomsCloud.Model
{

    /// <summary>
    /// Model for FaxInfoCollectionResponseModel
    /// </summary>
    [DataContract]
    public class FaxInfoCollectionResponseModel :  IEquatable<FaxInfoCollectionResponseModel>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="FaxInfoCollectionResponseModel" /> class.
        /// </summary>
        public FaxInfoCollectionResponseModel()
        {
            
        }

        
        /// <summary>
        /// Gets or Sets Records
        /// </summary>
        [DataMember(Name="records", EmitDefaultValue=false)]
        public FaxInfoModel Records { get; set; }
  
        
  
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class FaxInfoCollectionResponseModel {\n");
            sb.Append("  Records: ").Append(Records).Append("\n");
            
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as FaxInfoCollectionResponseModel);
        }

        /// <summary>
        /// Returns true if FaxInfoCollectionResponseModel instances are equal
        /// </summary>
        /// <param name="other">Instance of FaxInfoCollectionResponseModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(FaxInfoCollectionResponseModel other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.Records == other.Records ||
                    this.Records != null &&
                    this.Records.Equals(other.Records)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                
                if (this.Records != null)
                    hash = hash * 59 + this.Records.GetHashCode();
                
                return hash;
            }
        }

    }
}
