using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace Com.Telecomscloud.Api.TelecomsCloud.Model
{

    /// <summary>
    /// Model for FaxInfoModel
    /// </summary>
    [DataContract]
    public class FaxInfoModel :  IEquatable<FaxInfoModel>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="FaxInfoModel" /> class.
        /// </summary>
        public FaxInfoModel()
        {
            
        }

        
        /// <summary>
        /// Gets or Sets FromNumber
        /// </summary>
        [DataMember(Name="from_number", EmitDefaultValue=false)]
        public string FromNumber { get; set; }
  
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }
  
        
        /// <summary>
        /// Gets or Sets PageCount
        /// </summary>
        [DataMember(Name="page_count", EmitDefaultValue=false)]
        public int? PageCount { get; set; }
  
        
        /// <summary>
        /// Gets or Sets Pointer
        /// </summary>
        [DataMember(Name="pointer", EmitDefaultValue=false)]
        public int? Pointer { get; set; }
  
        
        /// <summary>
        /// Gets or Sets ReceivedDate
        /// </summary>
        [DataMember(Name="received_date", EmitDefaultValue=false)]
        public string ReceivedDate { get; set; }
  
        
        /// <summary>
        /// Gets or Sets ServiceNumber
        /// </summary>
        [DataMember(Name="service_number", EmitDefaultValue=false)]
        public string ServiceNumber { get; set; }
  
        
        /// <summary>
        /// Gets or Sets TiffBytes
        /// </summary>
        [DataMember(Name="tiff_bytes", EmitDefaultValue=false)]
        public int? TiffBytes { get; set; }
  
        
  
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class FaxInfoModel {\n");
            sb.Append("  FromNumber: ").Append(FromNumber).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  PageCount: ").Append(PageCount).Append("\n");
            sb.Append("  Pointer: ").Append(Pointer).Append("\n");
            sb.Append("  ReceivedDate: ").Append(ReceivedDate).Append("\n");
            sb.Append("  ServiceNumber: ").Append(ServiceNumber).Append("\n");
            sb.Append("  TiffBytes: ").Append(TiffBytes).Append("\n");
            
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as FaxInfoModel);
        }

        /// <summary>
        /// Returns true if FaxInfoModel instances are equal
        /// </summary>
        /// <param name="other">Instance of FaxInfoModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(FaxInfoModel other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.FromNumber == other.FromNumber ||
                    this.FromNumber != null &&
                    this.FromNumber.Equals(other.FromNumber)
                ) && 
                (
                    this.Id == other.Id ||
                    this.Id != null &&
                    this.Id.Equals(other.Id)
                ) && 
                (
                    this.PageCount == other.PageCount ||
                    this.PageCount != null &&
                    this.PageCount.Equals(other.PageCount)
                ) && 
                (
                    this.Pointer == other.Pointer ||
                    this.Pointer != null &&
                    this.Pointer.Equals(other.Pointer)
                ) && 
                (
                    this.ReceivedDate == other.ReceivedDate ||
                    this.ReceivedDate != null &&
                    this.ReceivedDate.Equals(other.ReceivedDate)
                ) && 
                (
                    this.ServiceNumber == other.ServiceNumber ||
                    this.ServiceNumber != null &&
                    this.ServiceNumber.Equals(other.ServiceNumber)
                ) && 
                (
                    this.TiffBytes == other.TiffBytes ||
                    this.TiffBytes != null &&
                    this.TiffBytes.Equals(other.TiffBytes)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                
                if (this.FromNumber != null)
                    hash = hash * 59 + this.FromNumber.GetHashCode();
                
                if (this.Id != null)
                    hash = hash * 59 + this.Id.GetHashCode();
                
                if (this.PageCount != null)
                    hash = hash * 59 + this.PageCount.GetHashCode();
                
                if (this.Pointer != null)
                    hash = hash * 59 + this.Pointer.GetHashCode();
                
                if (this.ReceivedDate != null)
                    hash = hash * 59 + this.ReceivedDate.GetHashCode();
                
                if (this.ServiceNumber != null)
                    hash = hash * 59 + this.ServiceNumber.GetHashCode();
                
                if (this.TiffBytes != null)
                    hash = hash * 59 + this.TiffBytes.GetHashCode();
                
                return hash;
            }
        }

    }
}
