using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace Com.Telecomscloud.Api.TelecomsCloud.Model
{

    /// <summary>
    /// Model for FaxOutboundGetStatusResponseModel
    /// </summary>
    [DataContract]
    public class FaxOutboundGetStatusResponseModel :  IEquatable<FaxOutboundGetStatusResponseModel>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="FaxOutboundGetStatusResponseModel" /> class.
        /// </summary>
        public FaxOutboundGetStatusResponseModel()
        {
            
        }

        
        /// <summary>
        /// Gets or Sets CompleteDatetime
        /// </summary>
        [DataMember(Name="complete_datetime", EmitDefaultValue=false)]
        public string CompleteDatetime { get; set; }
  
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }
  
        
        /// <summary>
        /// Gets or Sets Status
        /// </summary>
        [DataMember(Name="status", EmitDefaultValue=false)]
        public string Status { get; set; }
  
        
        /// <summary>
        /// Gets or Sets StatusCode
        /// </summary>
        [DataMember(Name="status_code", EmitDefaultValue=false)]
        public int? StatusCode { get; set; }
  
        
        /// <summary>
        /// Gets or Sets SubmitDatetime
        /// </summary>
        [DataMember(Name="submit_datetime", EmitDefaultValue=false)]
        public string SubmitDatetime { get; set; }
  
        
        /// <summary>
        /// Gets or Sets To
        /// </summary>
        [DataMember(Name="to", EmitDefaultValue=false)]
        public string To { get; set; }
  
        
  
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class FaxOutboundGetStatusResponseModel {\n");
            sb.Append("  CompleteDatetime: ").Append(CompleteDatetime).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Status: ").Append(Status).Append("\n");
            sb.Append("  StatusCode: ").Append(StatusCode).Append("\n");
            sb.Append("  SubmitDatetime: ").Append(SubmitDatetime).Append("\n");
            sb.Append("  To: ").Append(To).Append("\n");
            
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as FaxOutboundGetStatusResponseModel);
        }

        /// <summary>
        /// Returns true if FaxOutboundGetStatusResponseModel instances are equal
        /// </summary>
        /// <param name="other">Instance of FaxOutboundGetStatusResponseModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(FaxOutboundGetStatusResponseModel other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.CompleteDatetime == other.CompleteDatetime ||
                    this.CompleteDatetime != null &&
                    this.CompleteDatetime.Equals(other.CompleteDatetime)
                ) && 
                (
                    this.Id == other.Id ||
                    this.Id != null &&
                    this.Id.Equals(other.Id)
                ) && 
                (
                    this.Status == other.Status ||
                    this.Status != null &&
                    this.Status.Equals(other.Status)
                ) && 
                (
                    this.StatusCode == other.StatusCode ||
                    this.StatusCode != null &&
                    this.StatusCode.Equals(other.StatusCode)
                ) && 
                (
                    this.SubmitDatetime == other.SubmitDatetime ||
                    this.SubmitDatetime != null &&
                    this.SubmitDatetime.Equals(other.SubmitDatetime)
                ) && 
                (
                    this.To == other.To ||
                    this.To != null &&
                    this.To.Equals(other.To)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                
                if (this.CompleteDatetime != null)
                    hash = hash * 59 + this.CompleteDatetime.GetHashCode();
                
                if (this.Id != null)
                    hash = hash * 59 + this.Id.GetHashCode();
                
                if (this.Status != null)
                    hash = hash * 59 + this.Status.GetHashCode();
                
                if (this.StatusCode != null)
                    hash = hash * 59 + this.StatusCode.GetHashCode();
                
                if (this.SubmitDatetime != null)
                    hash = hash * 59 + this.SubmitDatetime.GetHashCode();
                
                if (this.To != null)
                    hash = hash * 59 + this.To.GetHashCode();
                
                return hash;
            }
        }

    }
}
