using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace Com.Telecomscloud.Api.TelecomsCloud.Model
{

    /// <summary>
    /// Model for LocalityInfoResponseModel
    /// </summary>
    [DataContract]
    public class LocalityInfoResponseModel :  IEquatable<LocalityInfoResponseModel>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="LocalityInfoResponseModel" /> class.
        /// </summary>
        public LocalityInfoResponseModel()
        {
            
        }

        
        /// <summary>
        /// Gets or Sets AreaCode
        /// </summary>
        [DataMember(Name="area_code", EmitDefaultValue=false)]
        public string AreaCode { get; set; }
  
        
        /// <summary>
        /// Gets or Sets FibreDate
        /// </summary>
        [DataMember(Name="fibre_date", EmitDefaultValue=false)]
        public string FibreDate { get; set; }
  
        
        /// <summary>
        /// Gets or Sets FibreType
        /// </summary>
        [DataMember(Name="fibre_type", EmitDefaultValue=false)]
        public string FibreType { get; set; }
  
        
        /// <summary>
        /// Gets or Sets IpstreamStatus
        /// </summary>
        [DataMember(Name="ipstream_status", EmitDefaultValue=false)]
        public string IpstreamStatus { get; set; }
  
        
        /// <summary>
        /// Gets or Sets Isoa2
        /// </summary>
        [DataMember(Name="isoa2", EmitDefaultValue=false)]
        public string Isoa2 { get; set; }
  
        
        /// <summary>
        /// Gets or Sets LocalityName
        /// </summary>
        [DataMember(Name="locality_name", EmitDefaultValue=false)]
        public string LocalityName { get; set; }
  
        
        /// <summary>
        /// Gets or Sets OperatorName
        /// </summary>
        [DataMember(Name="operator_name", EmitDefaultValue=false)]
        public string OperatorName { get; set; }
  
        
        /// <summary>
        /// Gets or Sets PartialNumber
        /// </summary>
        [DataMember(Name="partial_number", EmitDefaultValue=false)]
        public string PartialNumber { get; set; }
  
        
        /// <summary>
        /// Gets or Sets PostCode
        /// </summary>
        [DataMember(Name="post_code", EmitDefaultValue=false)]
        public string PostCode { get; set; }
  
        
        /// <summary>
        /// Gets or Sets PostTown
        /// </summary>
        [DataMember(Name="post_town", EmitDefaultValue=false)]
        public string PostTown { get; set; }
  
        
        /// <summary>
        /// Gets or Sets WbcStatus
        /// </summary>
        [DataMember(Name="wbc_status", EmitDefaultValue=false)]
        public string WbcStatus { get; set; }
  
        
  
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class LocalityInfoResponseModel {\n");
            sb.Append("  AreaCode: ").Append(AreaCode).Append("\n");
            sb.Append("  FibreDate: ").Append(FibreDate).Append("\n");
            sb.Append("  FibreType: ").Append(FibreType).Append("\n");
            sb.Append("  IpstreamStatus: ").Append(IpstreamStatus).Append("\n");
            sb.Append("  Isoa2: ").Append(Isoa2).Append("\n");
            sb.Append("  LocalityName: ").Append(LocalityName).Append("\n");
            sb.Append("  OperatorName: ").Append(OperatorName).Append("\n");
            sb.Append("  PartialNumber: ").Append(PartialNumber).Append("\n");
            sb.Append("  PostCode: ").Append(PostCode).Append("\n");
            sb.Append("  PostTown: ").Append(PostTown).Append("\n");
            sb.Append("  WbcStatus: ").Append(WbcStatus).Append("\n");
            
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as LocalityInfoResponseModel);
        }

        /// <summary>
        /// Returns true if LocalityInfoResponseModel instances are equal
        /// </summary>
        /// <param name="other">Instance of LocalityInfoResponseModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(LocalityInfoResponseModel other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.AreaCode == other.AreaCode ||
                    this.AreaCode != null &&
                    this.AreaCode.Equals(other.AreaCode)
                ) && 
                (
                    this.FibreDate == other.FibreDate ||
                    this.FibreDate != null &&
                    this.FibreDate.Equals(other.FibreDate)
                ) && 
                (
                    this.FibreType == other.FibreType ||
                    this.FibreType != null &&
                    this.FibreType.Equals(other.FibreType)
                ) && 
                (
                    this.IpstreamStatus == other.IpstreamStatus ||
                    this.IpstreamStatus != null &&
                    this.IpstreamStatus.Equals(other.IpstreamStatus)
                ) && 
                (
                    this.Isoa2 == other.Isoa2 ||
                    this.Isoa2 != null &&
                    this.Isoa2.Equals(other.Isoa2)
                ) && 
                (
                    this.LocalityName == other.LocalityName ||
                    this.LocalityName != null &&
                    this.LocalityName.Equals(other.LocalityName)
                ) && 
                (
                    this.OperatorName == other.OperatorName ||
                    this.OperatorName != null &&
                    this.OperatorName.Equals(other.OperatorName)
                ) && 
                (
                    this.PartialNumber == other.PartialNumber ||
                    this.PartialNumber != null &&
                    this.PartialNumber.Equals(other.PartialNumber)
                ) && 
                (
                    this.PostCode == other.PostCode ||
                    this.PostCode != null &&
                    this.PostCode.Equals(other.PostCode)
                ) && 
                (
                    this.PostTown == other.PostTown ||
                    this.PostTown != null &&
                    this.PostTown.Equals(other.PostTown)
                ) && 
                (
                    this.WbcStatus == other.WbcStatus ||
                    this.WbcStatus != null &&
                    this.WbcStatus.Equals(other.WbcStatus)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                
                if (this.AreaCode != null)
                    hash = hash * 59 + this.AreaCode.GetHashCode();
                
                if (this.FibreDate != null)
                    hash = hash * 59 + this.FibreDate.GetHashCode();
                
                if (this.FibreType != null)
                    hash = hash * 59 + this.FibreType.GetHashCode();
                
                if (this.IpstreamStatus != null)
                    hash = hash * 59 + this.IpstreamStatus.GetHashCode();
                
                if (this.Isoa2 != null)
                    hash = hash * 59 + this.Isoa2.GetHashCode();
                
                if (this.LocalityName != null)
                    hash = hash * 59 + this.LocalityName.GetHashCode();
                
                if (this.OperatorName != null)
                    hash = hash * 59 + this.OperatorName.GetHashCode();
                
                if (this.PartialNumber != null)
                    hash = hash * 59 + this.PartialNumber.GetHashCode();
                
                if (this.PostCode != null)
                    hash = hash * 59 + this.PostCode.GetHashCode();
                
                if (this.PostTown != null)
                    hash = hash * 59 + this.PostTown.GetHashCode();
                
                if (this.WbcStatus != null)
                    hash = hash * 59 + this.WbcStatus.GetHashCode();
                
                return hash;
            }
        }

    }
}
