using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace Com.Telecomscloud.Api.TelecomsCloud.Model
{

    /// <summary>
    /// Model for SmsOutboundGetStatusResponseModel
    /// </summary>
    [DataContract]
    public class SmsOutboundGetStatusResponseModel :  IEquatable<SmsOutboundGetStatusResponseModel>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SmsOutboundGetStatusResponseModel" /> class.
        /// </summary>
        public SmsOutboundGetStatusResponseModel()
        {
            
        }

        
        /// <summary>
        /// Gets or Sets DispatchDatetime
        /// </summary>
        [DataMember(Name="dispatch_datetime", EmitDefaultValue=false)]
        public string DispatchDatetime { get; set; }
  
        
        /// <summary>
        /// Gets or Sets From
        /// </summary>
        [DataMember(Name="from", EmitDefaultValue=false)]
        public string From { get; set; }
  
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }
  
        
        /// <summary>
        /// Gets or Sets ReceiptReceivedDatetime
        /// </summary>
        [DataMember(Name="receipt_received_datetime", EmitDefaultValue=false)]
        public string ReceiptReceivedDatetime { get; set; }
  
        
        /// <summary>
        /// Gets or Sets ReceiptStatusCode
        /// </summary>
        [DataMember(Name="receipt_status_code", EmitDefaultValue=false)]
        public int? ReceiptStatusCode { get; set; }
  
        
        /// <summary>
        /// Gets or Sets Status
        /// </summary>
        [DataMember(Name="status", EmitDefaultValue=false)]
        public string Status { get; set; }
  
        
        /// <summary>
        /// Gets or Sets StatusCode
        /// </summary>
        [DataMember(Name="status_code", EmitDefaultValue=false)]
        public int? StatusCode { get; set; }
  
        
        /// <summary>
        /// Gets or Sets SubmitDatetime
        /// </summary>
        [DataMember(Name="submit_datetime", EmitDefaultValue=false)]
        public string SubmitDatetime { get; set; }
  
        
        /// <summary>
        /// Gets or Sets To
        /// </summary>
        [DataMember(Name="to", EmitDefaultValue=false)]
        public string To { get; set; }
  
        
  
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class SmsOutboundGetStatusResponseModel {\n");
            sb.Append("  DispatchDatetime: ").Append(DispatchDatetime).Append("\n");
            sb.Append("  From: ").Append(From).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  ReceiptReceivedDatetime: ").Append(ReceiptReceivedDatetime).Append("\n");
            sb.Append("  ReceiptStatusCode: ").Append(ReceiptStatusCode).Append("\n");
            sb.Append("  Status: ").Append(Status).Append("\n");
            sb.Append("  StatusCode: ").Append(StatusCode).Append("\n");
            sb.Append("  SubmitDatetime: ").Append(SubmitDatetime).Append("\n");
            sb.Append("  To: ").Append(To).Append("\n");
            
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as SmsOutboundGetStatusResponseModel);
        }

        /// <summary>
        /// Returns true if SmsOutboundGetStatusResponseModel instances are equal
        /// </summary>
        /// <param name="other">Instance of SmsOutboundGetStatusResponseModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SmsOutboundGetStatusResponseModel other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.DispatchDatetime == other.DispatchDatetime ||
                    this.DispatchDatetime != null &&
                    this.DispatchDatetime.Equals(other.DispatchDatetime)
                ) && 
                (
                    this.From == other.From ||
                    this.From != null &&
                    this.From.Equals(other.From)
                ) && 
                (
                    this.Id == other.Id ||
                    this.Id != null &&
                    this.Id.Equals(other.Id)
                ) && 
                (
                    this.ReceiptReceivedDatetime == other.ReceiptReceivedDatetime ||
                    this.ReceiptReceivedDatetime != null &&
                    this.ReceiptReceivedDatetime.Equals(other.ReceiptReceivedDatetime)
                ) && 
                (
                    this.ReceiptStatusCode == other.ReceiptStatusCode ||
                    this.ReceiptStatusCode != null &&
                    this.ReceiptStatusCode.Equals(other.ReceiptStatusCode)
                ) && 
                (
                    this.Status == other.Status ||
                    this.Status != null &&
                    this.Status.Equals(other.Status)
                ) && 
                (
                    this.StatusCode == other.StatusCode ||
                    this.StatusCode != null &&
                    this.StatusCode.Equals(other.StatusCode)
                ) && 
                (
                    this.SubmitDatetime == other.SubmitDatetime ||
                    this.SubmitDatetime != null &&
                    this.SubmitDatetime.Equals(other.SubmitDatetime)
                ) && 
                (
                    this.To == other.To ||
                    this.To != null &&
                    this.To.Equals(other.To)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                
                if (this.DispatchDatetime != null)
                    hash = hash * 59 + this.DispatchDatetime.GetHashCode();
                
                if (this.From != null)
                    hash = hash * 59 + this.From.GetHashCode();
                
                if (this.Id != null)
                    hash = hash * 59 + this.Id.GetHashCode();
                
                if (this.ReceiptReceivedDatetime != null)
                    hash = hash * 59 + this.ReceiptReceivedDatetime.GetHashCode();
                
                if (this.ReceiptStatusCode != null)
                    hash = hash * 59 + this.ReceiptStatusCode.GetHashCode();
                
                if (this.Status != null)
                    hash = hash * 59 + this.Status.GetHashCode();
                
                if (this.StatusCode != null)
                    hash = hash * 59 + this.StatusCode.GetHashCode();
                
                if (this.SubmitDatetime != null)
                    hash = hash * 59 + this.SubmitDatetime.GetHashCode();
                
                if (this.To != null)
                    hash = hash * 59 + this.To.GetHashCode();
                
                return hash;
            }
        }

    }
}
