using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace Com.Telecomscloud.Api.TelecomsCloud.Model
{

    /// <summary>
    /// Model for SmsOutboundSendResponseModel
    /// </summary>
    [DataContract]
    public class SmsOutboundSendResponseModel :  IEquatable<SmsOutboundSendResponseModel>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SmsOutboundSendResponseModel" /> class.
        /// </summary>
        public SmsOutboundSendResponseModel()
        {
            
        }

        
        /// <summary>
        /// Gets or Sets From
        /// </summary>
        [DataMember(Name="from", EmitDefaultValue=false)]
        public string From { get; set; }
  
        
        /// <summary>
        /// Gets or Sets Message
        /// </summary>
        [DataMember(Name="message", EmitDefaultValue=false)]
        public string Message { get; set; }
  
        
        /// <summary>
        /// Gets or Sets NumberFormatLocation
        /// </summary>
        [DataMember(Name="numberFormatLocation", EmitDefaultValue=false)]
        public string NumberFormatLocation { get; set; }
  
        
        /// <summary>
        /// Gets or Sets To
        /// </summary>
        [DataMember(Name="to", EmitDefaultValue=false)]
        public string To { get; set; }
  
        
  
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class SmsOutboundSendResponseModel {\n");
            sb.Append("  From: ").Append(From).Append("\n");
            sb.Append("  Message: ").Append(Message).Append("\n");
            sb.Append("  NumberFormatLocation: ").Append(NumberFormatLocation).Append("\n");
            sb.Append("  To: ").Append(To).Append("\n");
            
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as SmsOutboundSendResponseModel);
        }

        /// <summary>
        /// Returns true if SmsOutboundSendResponseModel instances are equal
        /// </summary>
        /// <param name="other">Instance of SmsOutboundSendResponseModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SmsOutboundSendResponseModel other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.From == other.From ||
                    this.From != null &&
                    this.From.Equals(other.From)
                ) && 
                (
                    this.Message == other.Message ||
                    this.Message != null &&
                    this.Message.Equals(other.Message)
                ) && 
                (
                    this.NumberFormatLocation == other.NumberFormatLocation ||
                    this.NumberFormatLocation != null &&
                    this.NumberFormatLocation.Equals(other.NumberFormatLocation)
                ) && 
                (
                    this.To == other.To ||
                    this.To != null &&
                    this.To.Equals(other.To)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                
                if (this.From != null)
                    hash = hash * 59 + this.From.GetHashCode();
                
                if (this.Message != null)
                    hash = hash * 59 + this.Message.GetHashCode();
                
                if (this.NumberFormatLocation != null)
                    hash = hash * 59 + this.NumberFormatLocation.GetHashCode();
                
                if (this.To != null)
                    hash = hash * 59 + this.To.GetHashCode();
                
                return hash;
            }
        }

    }
}
